local function indexOfNumberThing(array, value)
    for i, v in ipairs(array) do
        if v.hudnumber == value then
            return i
        end
    end
    return nil
end

--customhud.SetupFont("KHFNT", 0, 3)
local Font1 = "KHFNT"
local Font2 = "KHMNT"

local function khaostext(v, player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos then return end
    local khaosoptions = {
        SRB2CE_HUD_Position = player.khaosoptions.SRB2CE_HUD_Position,
        SRB2CE_HUD = player.khaosoptions.SRB2CE_HUD,
        SRB2CE_HUD_Text_Border = player.khaosoptions.SRB2CE_HUD_Text_Border,
        SRB2CE_HUD_Text_Border_Type = player.khaosoptions.SRB2CE_HUD_Text_Border_Type
    }

    local EXTRAFLAG = V_SNAPTOBOTTOM
    if khaosoptions.SRB2CE_HUD_Position then
        EXTRAFLAG = V_SNAPTOTOP
    end

    local funnyindexer = 0

    -- khaos hud text --
    for key, value in pairs(player.khaostext) do
        funnyindexer = $ + 1
        local yoffset = 0
        local realy = 164-(12*(funnyindexer-1))
        if khaosoptions.SRB2CE_HUD_Position then
            yoffset = -5 - player.khaos.HUDMoveUp
            realy = 28+(12*(funnyindexer-1))
        else
            yoffset = 0 + player.khaos.HUDMoveUp
        end

        local FLAGZ = value.flags
        if FLAGZ != nil then
            FLAGZ = $|EXTRAFLAG
        end
        if khaosoptions.SRB2CE_HUD_Text_Border then
            local left = "KH_LEFTBORDER"
            local right = "KH_RIGHTBORDER"
            if player.khaossp.hudtextborder then
                if khaosoptions.SRB2CE_HUD_Text_Border_Type == 1 then
                    left = "KH_LEFTBORDERTTK"
                    right = "KH_RIGHTBORDERTTK"
                elseif khaosoptions.SRB2CE_HUD_Text_Border_Type == 2 then
                    left = "KH_LEFTROUND"
                    right = "KH_RIGHTROUND"
                elseif khaosoptions.SRB2CE_HUD_Text_Border_Type == 3 then
                    left = "KH_LEFTTRI"
                    right = "KH_RIGHTTRI"
                end
            end
            --v.drawString(160, realy-yoffset - 2, value.text, FLAGZ, "thin-center")
            local silly = Fontlib.cachePatchWidth(v, value.text, Font1, 0)
            --border width & height: 11
            local sillyx = 160
            sillyx = $1-silly.linewidth/2
            local skincolorer = value.color or SKINCOLOR_WHITE
            v.draw(sillyx-11, realy-yoffset-3, v.cachePatch(left), EXTRAFLAG|value.trans<<V_ALPHASHIFT, v.getColormap(TC_DEFAULT, skincolorer))
            v.draw(sillyx+silly.linewidth, realy-yoffset-3, v.cachePatch(right), EXTRAFLAG|value.trans<<V_ALPHASHIFT, v.getColormap(TC_DEFAULT, skincolorer))
            v.drawFill(sillyx, realy-yoffset-3, silly.linewidth, 11, skincolors[skincolorer].ramp[11]|EXTRAFLAG|value.trans<<V_ALPHASHIFT)
        end

        Fontlib.drawString(v, 160, realy-yoffset - 3, value.text, {font = Font1, alpha = value.trans, extraflags = EXTRAFLAG}, "center")
    end

    if not khaosoptions.SRB2CE_HUD return end -- don't run the rest of the logic from here

    if not v.khaos.intialized then
        v.khaos.XCenterVirtual = 320/2
        v.khaos.intialized = true
    end

end

local function khaos(v, player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos then v.khaos.storetable = nil return end
    if not player.khaoseffects then v.khaos.storetable = nil return end
    if not SRB2CE_Enabled then v.khaos.storetable = nil return end
    if mapheaderinfo[gamemap].srb2cecity then v.khaos.storetable = nil return end
    local khaosoptions = {
        SRB2CE_HUD_Position = player.khaosoptions.SRB2CE_HUD_Position,
        SRB2CE_HUD = player.khaosoptions.SRB2CE_HUD,
        SRB2CE_HUD_Text_Border = player.khaosoptions.SRB2CE_HUD_Text_Border
    }

    local EXTRAFLAG = V_SNAPTOBOTTOM
    if khaosoptions.SRB2CE_HUD_Position then
        EXTRAFLAG = V_SNAPTOTOP
    end

    --[[if ((consoleplayer and consoleplayer.spectator) or replayplayback) and tonumber(CV_FindVar("SRB2CE_HUD_Override").value) then
        --override settings with the consoleplayer's settings
        khaosoptions = {
            SRB2CE_HUD_Position = tonumber(CV_FindVar("SRB2CE_HUD_Position").value),
            SRB2CE_HUD = tonumber(CV_FindVar("SRB2CE_HUD").value),
            SRB2CE_HUD_Text_Border = tonumber(CV_FindVar("SRB2CE_HUD_Text_Border").value)
        }
    end]]

    local funnyindexer = 0

    if player.khaos.UniEffectText and player.khaos.UniTextPopUpFade < 10 then
        Fontlib.drawString(v, 160, 54-10, ("\x87" + player.khaos.UniEffectTextBuffer), {font = Font2, alpha = player.khaos.UniTextPopUpFade}, "center")
        Fontlib.drawString(v, 160, 68-10, player.khaos.UniEffectSubTextBuffer, {font = Font1, alpha = player.khaos.UniTextPopUpFade}, "center")
        --v.drawString(160, 59, "\x87" + player.khaos.UniEffectTextBuffer, V_SNAPTOBOTTOM|player.khaos.UniTextPopUpFade<<V_ALPHASHIFT, "center")
        --v.drawString(160, 68, player.khaos.UniEffectSubTextBuffer, V_SNAPTOBOTTOM|player.khaos.UniTextPopUpFade<<V_ALPHASHIFT, "thin-center")
    end

    -- New HUD Logic --

    if khaosoptions.SRB2CE_HUD then
        local TotalEffects = 0
        for key, value in pairs(player.khaoseffects) do
            if value.icon or (not value.icon and value.name == "Roulette") then
                TotalEffects = $ + 1
            end
        end
        TotalEffects = $ + 2
        v.khaos.storetable = v.khaos.storetable or {} -- use effect.hudnumber
        local sillyindex = 0
        -- now we move on to the placement logic, so we can move everything around.
        for key, value in pairs(player.khaoseffects) do
            if value.icon or (not value.icon and value.name == "Roulette") then
                local tableplace = indexOfNumberThing(v.khaos.storetable, value.hudnumber)
                local fx = KhaosEffectsTable[value.effect] --DO NOT MODIFY THIS
                local gap = 0
                if funnyindexer > 0 then
                    gap = 2 * funnyindexer
                end

                if not tableplace then -- we don't exist yet!
                    local yset = (fx.name == "Roulette" and 30) or 0
                    table.insert(v.khaos.storetable, {hudnumber = value.hudnumber, x = (funnyindexer * 20) + gap, gotox = (funnyindexer * 20) + gap, yoffset = yset, removeme = value.removeme})
                end

                if tableplace and (value.removeme < 1) then -- skip over if we don't have tableplace, it shouldn't hurt
                    tableplace = v.khaos.storetable[tableplace]

                    --adjust desired X position

                    tableplace.x = (funnyindexer * 20) + gap

                    if tableplace.gotox < tableplace.x then
                        tableplace.gotox = $ + 1
                    elseif tableplace.gotox > tableplace.x then
                        tableplace.gotox = $ - 1
                    end

                    funnyindexer = $ + 1
                end
            end
        end

        local TotalLength = (funnyindexer * 20) + ((funnyindexer-1) * 2)
        local screenwidth = 320
        local XCenter = ((screenwidth/2) - (TotalLength/2))

        v.khaos.NeoXCenterVirtual = v.khaos.NeoXCenterVirtual or XCenter

        if v.khaos.NeoXCenterVirtual != XCenter then
            if v.khaos.NeoXCenterVirtual < XCenter then
                v.khaos.NeoXCenterVirtual = $ + 1
            elseif v.khaos.NeoXCenterVirtual > XCenter then
                v.khaos.NeoXCenterVirtual = $ - 1
            end
        end

        local theypos = 173
        local markiplier = 1 --i don't even watch him, it's just a funny variable name
        if khaosoptions.SRB2CE_HUD_Position then
            theypos = 8
            markiplier = -1
        end
        -- change if HUD is on the top.

        -- now we render everything out, after doing that centering math
        for key, value in pairs(player.khaoseffects) do
            local tableplace = indexOfNumberThing(v.khaos.storetable, value.hudnumber)
            if value.icon or (not value.icon and value.name == "Roulette") then
                if tableplace and (value.removeme < 1) then
                    tableplace = v.khaos.storetable[tableplace]
                    local fx = KhaosEffectsTable[value.effect]
                    local border = "NEUTRAL"
                    if fx.etype == "good" then
                        border = "GOOD"
                    elseif fx.etype == "bad" then
                        border = "BAD"
                    elseif fx.etype == "bees" then
                        border = "BEEBORDER"
                    end

                    local spritz = "KH_PLACEHOLDER"
                    if value.icon then
                        spritz = value.icon
                    end

                    if not fx.noblink and fx.duration > 0 and (value.duration*TICRATE - value.timer < 3*TICRATE and (value.timer % 2 == 0)) then
                        spritz = "KH_NOTHINGSHAKE"
                        if VERSION >= 2 then --randomchance didn't exist in v2.1 blua? wtf?
                            if v.RandomChance(FRACUNIT/2 + FRACUNIT/4) then
                                spritz = "KH_STATICSHAKE1"
                                if v.RandomChance(FRACUNIT/2) then
                                    spritz = "KH_STATICSHAKE2"
                                end
                            end
                        end
                        border = "NEUTRALSHAKE"

                        if fx.etype == "good" then
                            border = "GOODSHAKE"
                        elseif fx.etype == "bad" then
                            border = "BADSHAKE"
                        end
                    end

                    if VERSION >= 2 then
                        border = "KH_" + $
                    else
                        border = "CH_" + $
                    end

                    if tableplace.yoffset > 0 then
                        tableplace.yoffset = $ - 1
                    end

                    v.draw(v.khaos.NeoXCenterVirtual+tableplace.gotox+2, theypos+2+(markiplier*tableplace.yoffset), v.cachePatch(spritz), EXTRAFLAG) -- icon
                    v.draw(v.khaos.NeoXCenterVirtual+tableplace.gotox, theypos+(markiplier*tableplace.yoffset), v.cachePatch(border), EXTRAFLAG) -- border
                    if not value.notimer then v.drawString(v.khaos.NeoXCenterVirtual+tableplace.gotox+1, theypos+1, (value.duration*TICRATE - value.timer)/TICRATE + 1, V_30TRANS|EXTRAFLAG, "thin") end -- timer, duh.
                elseif tableplace and value.removeme then
                    tableplace = v.khaos.storetable[tableplace]
                    tableplace.removeme = value.removeme
                    local fx = KhaosEffectsTable[value.effect]
                    if not tableplace.SetX then -- keep that effect icon in it's place
                        tableplace.gotox = v.khaos.NeoXCenterVirtual + tableplace.x
                        tableplace.SetX = true
                    end
                    local spritz = "KH_PLACEHOLDER"
                    if value.icon then
                        spritz = value.icon
                    end

                    local scaler = min(FRACUNIT, (FRACUNIT/value.removeme)*8)
                    local DyingCenter = (16 * scaler)/2 -- wouldn't that be called a morgue
                    local Plus = DyingCenter + DyingCenter

                    v.drawScaled((tableplace.gotox+2)*FRACUNIT, (theypos+2)*FRACUNIT, scaler, v.cachePatch(spritz), EXTRAFLAG|((value.removeme-1)/4)<<V_ALPHASHIFT) -- icon
                end
            end
        end

        for index, value in ipairs(v.khaos.storetable) do
            if value.removeme >= 39 then
                table.remove(v.khaos.storetable, index)
            end
        end

        if #player.khaoseffects == 0 then
            v.khaos.storetable = {} -- reset this, just for in case we didn't remove everything.
        end
    end

    local textpopupcolor = "\x85"
    if #player.khaossp.khaosblacklist == 0 then
        textpopupcolor = "\x83"
    elseif #player.khaossp.khaosblacklist <= 2 then
        textpopupcolor = "\x82"
    end

    if player.khaos.TextPopUpFade < 10 then
        local AdderText = (SRB2CE.AmplifyChecker(player) and ", Amplify Active!") or ""
        local sillything = "thin-center"
        if VERSION < 2 then
            sillything = "center"
        end
        local extraflags = (VERSION < 2 and V_ALLOWLOWERCASE) or 0
        --if player.khaos.respawnmeinchief then v.drawString(160, 180, "\x82" + "KHAOS SYSTEM HAS REBOOTED!", extraflags|V_SNAPTOBOTTOM|player.khaos.TextPopUpFade<<V_ALPHASHIFT, sillything) end
        v.drawString(160, 188, textpopupcolor + "SRB2: Chaotic Edition v" + SRB2CE.version + AdderText, extraflags|V_SNAPTOBOTTOM|V_ALLOWLOWERCASE|player.khaos.TextPopUpFade<<V_ALPHASHIFT, sillything)
    end
end

local function timerhud(v,player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos then return end
    if not SRB2CE_Enabled return end
    if mapheaderinfo[gamemap].srb2cecity return end

    local khaosoptions = {
        SRB2CE_HUD_Position = player.khaosoptions.SRB2CE_HUD_Position,
        SRB2CE_HUD = player.khaosoptions.SRB2CE_HUD,
        SRB2CE_HUD_Timer_Bar = player.khaosoptions.SRB2CE_HUD_Timer_Bar,
        SRB2CE_HUD_Timer_Color = player.khaosoptions.SRB2CE_HUD_Timer_Color
    }

    --[[if ((consoleplayer and consoleplayer.spectator)) and tonumber(CV_FindVar("SRB2CE_HUD_Override").value) then
        --override settings with the consoleplayer's settings
        khaosoptions = {
            SRB2CE_HUD_Position = tonumber(CV_FindVar("SRB2CE_HUD_Position").value),
            SRB2CE_HUD = tonumber(CV_FindVar("SRB2CE_HUD").value),
            SRB2CE_HUD_Timer_Bar = tonumber(CV_FindVar("SRB2CE_HUD_Timer_Bar").value),
            SRB2CE_HUD_Timer_Color = tonumber(CV_FindVar("SRB2CE_HUD_Timer_Color").value)
        }
    end]]

    if not khaosoptions.SRB2CE_HUD or not khaosoptions.SRB2CE_HUD_Timer_Bar then return end
    --if leveltime < 236 or player.exiting then return end  -- PF_FINISHED
    local width = v.width()/v.dupx() --320
    local height = 3
    local x = 0
    local y = 200-height
    local SNAP = V_SNAPTOBOTTOM

    local MaxTime = player.khaos.WaitTime or 10*TICRATE

    if khaosoptions.SRB2CE_HUD_Position then
        y = 0
        SNAP = V_SNAPTOTOP
    end

    if not v.khaos.color then
        v.khaos.color = 0
    end

    local screenwidth = 320
    local XCenter = ((screenwidth/2) - (width/2))

    -- player.khaos.timer > player.khaos.WaitTime

    local soup = FixedDiv(player.khaos.timer, MaxTime)
    local souper = FixedMul(width, soup)


    if khaosoptions.SRB2CE_HUD_Timer_Color == 2 and player.khaossp.timerbarcolors then
        v.khaos.colorset = SRB2CE.rainbowcolors[((leveltime/2) % #SRB2CE.rainbowcolors)+1]
        v.khaos.altcolor = v.khaos.colorset + 5
    elseif khaosoptions.SRB2CE_HUD_Timer_Color == 1 and player.khaossp.timerbarcolors
        if VERSION >= 2 then
            v.khaos.colorset = skincolors[player.skincolor].ramp[8]
            v.khaos.altcolor = skincolors[player.skincolor].ramp[13]
        else
            v.khaos.colorset = 132
            v.khaos.altcolor = v.khaos.colorset + 5
        end
    else
        v.khaos.colorset = 36
        v.khaos.altcolor = v.khaos.colorset + 5
        if VERSION < 2 then
            v.khaos.colorset = 132
            v.khaos.altcolor = v.khaos.colorset + 5
        end
    end

    v.drawFill(XCenter, y, width, height, 31|SNAP)
    v.drawFill(XCenter, y, souper, height, v.khaos.altcolor|SNAP) -- filling timer bar, before the two pixel gap
    v.drawFill(XCenter, y, souper-2, height, v.khaos.colorset|SNAP) -- the actual color for the timer bar


    if SRB2CE.ueTimer != nil and not SRB2CE.ueTimerDisabled then
        local soup2 = FixedDiv(SRB2CE.ueTimer, SRB2CE.ueTimerMax)
        local souper2 = FixedMul(width, soup2)
        local theadditioner = -3
        if khaosoptions.SRB2CE_HUD_Position then
            theadditioner = 4 --idk why it has to be one more
        end
        --85 for srb2kart
        v.khaos.colorset2 = 53
        if VERSION < 2 then
            v.khaos.colorset2 = 85
        end
        v.drawFill(XCenter, y+theadditioner, width, height-1, 31|SNAP)
        v.drawFill(XCenter, y+theadditioner, souper2, height-1, v.khaos.colorset2+5|SNAP) -- filling timer bar, before the two pixel gap
        v.drawFill(XCenter, y+theadditioner, souper2-2, height-1, v.khaos.colorset2|SNAP) -- the actual color for the timer bar
    end
end

local function darkvisionhud(v, player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos then return end
    if not SRB2CE then return end
    if not SRB2CE_Enabled return end
    if mapheaderinfo[gamemap].srb2cecity return end

	if v.khaos.TransBack == nil
		v.khaos.TransBack = 10
	end

	if player.khaos.DarkenedVisionNow then
		if ((leveltime % 2 == 0) and (SRB2CE.AmplifyChecker(player) and v.khaos.TransBack > 2)) or (not SRB2CE.AmplifyChecker(player) and v.khaos.TransBack > 3) then
			v.khaos.TransBack = $ - 1
		end
	else
		if (leveltime % 2 == 0) and v.khaos.TransBack < 10 then
			v.khaos.TransBack = $ + 1
		end
	end
	v.khaos.TransFlags = v.khaos.TransBack<<V_ALPHASHIFT

    if v.khaos.TransBack < 10 then
	    v.drawScaled(0,200 , FRACUNIT*800, v.cachePatch("KH_DARK"), v.khaos.TransFlags|V_SNAPTOLEFT|V_SNAPTOTOP)
    end
end

local function borkscreen(v, player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos then return end
    if not SRB2CE then return end
    if not SRB2CE_Enabled return end
    if mapheaderinfo[gamemap].srb2cecity return end

	if v.khaos.TransBackTWO == nil
		v.khaos.TransBackTWO = 10
	end

	if player.khaos.BrokenScreenNow then
		if ((leveltime % 2 == 0) and (SRB2CE.AmplifyChecker(player) and v.khaos.TransBackTWO > 3)) or (not SRB2CE.AmplifyChecker(player) and v.khaos.TransBackTWO > 4) then
			v.khaos.TransBackTWO = $ - 1
		end
	else
		if (leveltime % 2 == 0) and v.khaos.TransBackTWO < 10 then
			v.khaos.TransBackTWO = $ + 1
		end
	end
	v.khaos.TransFlagsTWO = v.khaos.TransBackTWO<<V_ALPHASHIFT

    if v.khaos.TransBackTWO < 10 then
	    v.drawScaled(0, 200, FRACUNIT/2 + FRACUNIT/4, v.cachePatch("KH_BORKSCREEN"), v.khaos.TransFlagsTWO|V_SNAPTOLEFT|V_SNAPTOTOP)
    end
end


local function dvdhud(v, player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos then return end
    if not player.khaos.DVDHud then v.khaos.dvdinit = false return end
    if mapheaderinfo[gamemap].srb2cecity return end
    if not SRB2CE_Enabled return end

    if v.khaos.dvdinit and ((v.khaos.gaywidth != v.width()/v.dupx()) or (v.khaos.gayheight != v.height()/v.dupy())) then -- someone changed their resolution settings, reset everything because i'm too lazy to do proper math
        v.khaos.dvdinit = false
        return
    end

    if not v.khaos.dvdinit then
        v.khaos.direction = "bottomright"
        if VERSION >= 2 then
            v.khaos.xpos = v.RandomRange(1, 75)
            v.khaos.ypos = v.RandomRange(1, 40)
            if v.RandomChance(FRACUNIT/2) then
                v.khaos.direction = "topright"
            end
        else
            v.khaos.xpos = 50
            v.khaos.ypos = 50
        end
        v.khaos.gaywidth = v.width()/v.dupx() -- true width without multipler
        v.khaos.gayheight = v.height()/v.dupy() -- true height without multipler

        v.khaos.logo = v.cachePatch("KH_DVDLOGO")
        v.khaos.dvdwidth = 190
        v.khaos.dvdheight = 85

        if player.khaos.HDDVD then -- random chance for HD DVD logo instead
            v.khaos.logo = v.cachePatch("KH_HDDVD")
            v.khaos.dvdwidth = 213
            v.khaos.dvdheight = 52
        end

        v.khaos.dvdinit = true
    end

    local directioneerX = {["topright"] = 1, -- quackulate the math needed, it'll go either postive or negative
    ["topleft"] = -1,
    ["bottomright"] = 1,
    ["bottomleft"] = -1}
    local directioneerY = {["topright"] = -1,
    ["topleft"] = -1,
    ["bottomright"] = 1,
    ["bottomleft"] = 1}

    local invertX = {["topright"] = "topleft",
    ["topleft"] = "topright",
    ["bottomright"] = "bottomleft",
    ["bottomleft"] = "bottomright"}
    local invertY = {["topright"] = "bottomright",
    ["topleft"] = "bottomleft",
    ["bottomright"] = "topright",
    ["bottomleft"] = "topleft"}

    if not player.khaos.Freezer then
        v.khaos.xpos = $ + directioneerX[v.khaos.direction]
        v.khaos.ypos = $ + directioneerY[v.khaos.direction]
    end

    if v.khaos.xpos + v.khaos.dvdwidth - v.khaos.gaywidth >= 0 or v.khaos.xpos <= 0 then
        v.khaos.direction = invertX[v.khaos.direction]
    end

    if v.khaos.ypos + v.khaos.dvdheight - v.khaos.gayheight >= 0 or v.khaos.ypos <= 0 then
        v.khaos.direction = invertY[v.khaos.direction]
    end

    v.draw(v.khaos.xpos, v.khaos.ypos, v.khaos.logo, V_SNAPTOTOP|V_SNAPTOLEFT)
end

local function textboxhud(v, player) -- button prompt: 190, 101
    if not v.khaos then v.khaos = {} end
    if not SRB2CE then return end
    if not player.khaos then return end
    if not SRB2CE_Enabled return end
    if mapheaderinfo[gamemap].srb2cecity return end
    if not player.khaos.TextBoxStation then
        v.khaos.Page = nil
        return
    end
    if not v.khaos.Page then
        v.khaos.Page = player.khaos.TextBoxPage
        v.khaos.Text2Change = 0
        v.khaos.YAdjust = 0
        -- text position, page position
        v.khaos.Box = {{1, 1}, {2, 1}, {3, 1}, {4, 1}, {1, 2}}  -- text position, page position
        --v.khaos.Box5 = {1, 2}
    end

    if v.khaos.Page != player.khaos.TextBoxPage then
        v.khaos.YAdjust = $ - 3
        if v.khaos.YAdjust < -9 then
            v.khaos.Text2Change = $ + 1
            v.khaos.TextChangeNow = true
            v.khaos.YAdjust = 0
        end
    end

    local YMan = 68
    local Y5Text = 2
    if v.khaos.Text2Change < 4 then
        YMan = $ + v.khaos.YAdjust
        if v.khaos.Page != player.khaos.TextBoxPage then
            Y5Text = 0
        end
    end

    if v.khaos.TextChangeNow then
        if v.khaos.Text2Change < 5 then
            for key, value in pairs(v.khaos.Box) do
                value[1] = $ + 1
                if value[1] > 4 then
                    value[1] = 1
                    value[2] = $ + 1
                end
            end
        else
            v.khaos.Page = player.khaos.TextBoxPage
            v.khaos.Text2Change = 0
        end
        v.khaos.TextChangeNow = false
    end

    local Texter = player.khaos.TextBoxStation

    local Texter1 = SRB2CE.TextBoxTable[Texter][v.khaos.Box[1][2]][v.khaos.Box[1][1]]
    local Texter2 = SRB2CE.TextBoxTable[Texter][v.khaos.Box[2][2]][v.khaos.Box[2][1]]
    local Texter3 = SRB2CE.TextBoxTable[Texter][v.khaos.Box[3][2]][v.khaos.Box[3][1]]
    local Texter4 = SRB2CE.TextBoxTable[Texter][v.khaos.Box[4][2]][v.khaos.Box[4][1]]
    local Texter5 = ""
    if SRB2CE.TextBoxTable[Texter][v.khaos.Box[5][2]] then
        Texter5 = SRB2CE.TextBoxTable[Texter][v.khaos.Box[5][2]][v.khaos.Box[5][1]]
    end

    local extraflags = V_ALLOWLOWERCASE

    v.drawString(121, YMan+(0*9), Texter1, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")
    v.drawString(121, YMan+(1*9), Texter2, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")
    v.drawString(121, YMan+(2*9), Texter3, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")
    v.drawString(121, YMan+(3*9), Texter4, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")
    v.drawString(121, YMan+(4*9)+Y5Text, Texter5, extraflags|player.khaos.TextBoxFader<<V_ALPHASHIFT, "thin")

    --[[
    local character, flipped = v.getSprite2Patch(player.mo.skin, Spriter, false, Framer, Rotater)
    local colormap = v.getColormap(player.mo.skin, player.skincolor)
    local flags = nil
    if flipped == true then
        flags = V_FLIP
    end

    v.drawScaled(160*FRACUNIT, (totalyoffset*FRACUNIT) + (70*FRACUNIT), FRACUNIT, character, flags, colormap)]]

    local colormap = v.getColormap("sonic", player.skincolor) -- first value used to be player.mo.skin
    local sillybox = "KHTXA0"
    if VERSION < 2 then
        sillybox = "CHTXA0"
    end
    v.draw(112, 57, v.cachePatch(sillybox), player.khaos.TextBoxFader<<V_ALPHASHIFT, colormap)

    if VERSION >= 2 then
        local buttonspriter = "TLB_N"
        if player.khaos.HoldAccelerate then
            buttonspriter = "TLB_NB"
        end

        --v.draw(197, 105, v.cachePatch(buttonspriter), player.khaos.TextBoxFader<<V_ALPHASHIFT) --TODO: REPOSITION ME TO A BETTER LOCATION
    end

end

local ConfettiTable = {
{"CNFBA0", "CNFBB0", "CNFBC0", "CNFBD0", "CNFBE0", "CNFBF0", "CNFBG0", "CNFBH0"},
{"GNFBA0", "GNFBB0", "GNFBC0", "GNFBD0", "GNFBE0", "GNFBF0", "GNFBG0", "GNFBH0"},
{"GNFTA0", "GNFTB0", "GNFTC0", "GNFTD0", "GNFTE0", "GNFTF0", "GNFTG0", "GNFTH0"},
{"GNFTI0", "GNFTJ0", "GNFTK0", "GNFTL0", "GNFTM0", "GNFTN0", "GNFTO0", "GNFTP0"},
{"GNFTQ0", "GNFTR0", "GNFTS0", "GNFTT0", "GNFTU0", "GNFTV0", "GNFTW0", "GNFTX0"},
{"GNFTY0", "GNFTZ0", "GNFT00", "GNFT10", "GNFT20", "GNFT30", "GNFT40", "GNFT50"},
}

local RareConfetti = {"WBSCA0", "WBSCB0", "WBSCC0", "WBSCD0", "WBSCE0", "WBSCF0", "WBSCG0", "WBSCH0", "WBSCI0", "WBSCJ0", "WBSCK0", "WBSCL0", "WBSCM0", "WBSCN0", "WBSCO0", "WBSCP0", "WBSCQ0", "WBSCR0", "WBSCS0", "WBSCT0", "WBSCU0", "WBSCV0", "WBSCW0", "WBSCX0", "WBSCY0", "WBSCZ0", "WBSC00", "WBSC10", "WBSC20", "WBSC30", "WBSC40", "WBSC50", "WBSC60", "WBSC70", "WBSC80", "WBSC90", "WBSCa0", "WBSCb0", "WBSCc0", "WBSCd0", "WBSCe0", "WBSCf0", "WBSCg0", "WBSCh0", "WBSCi0", "WBSCj0", "WBSCk0"}

local RareConfettiTWO = {"KSKULL_00", "KSKULL_01", "KSKULL_02", "KSKULL_03", "KSKULL_04", "KSKULL_05", "KSKULL_06", "KSKULL_07", "KSKULL_08", "KSKULL_09", "KSKULL_10", "KSKULL_11", "KSKULL_12", "KSKULL_13", "KSKULL_14", "KSKULL_15", "KSKULL_16", "KSKULL_17", "KSKULL_18", "KSKULL_19", "KSKULL_20", "KSKULL_21", "KSKULL_22", "KSKULL_23"}


local function yourewinner(v, player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos then v.khaos.animator = nil return end
    if not SRB2CE_Enabled v.khaos.animator = nil return end
    if mapheaderinfo[gamemap].srb2cecity v.khaos.animator = nil return end

    if not v.khaos.animator then
        v.khaos.animator = {}
        --v.khaos.timer = 0
    end

    v.khaos.gaywidth = v.width()/v.dupx() -- true width without multipler
    v.khaos.gayheight = v.height()/v.dupy() -- true height without multipler
    --v.timer = $ + 1
    --if y + height surpasses gay height, then delete it from the table

    local divisor = 5
    if SRB2CE.AmplifyChecker(player) then
        divisor = 2
    end

    if player.khaos.yourewinner and (leveltime % divisor) == 0 then
        local snable = {spr = v.RandomRange(1, #ConfettiTable), x = v.RandomRange(1, v.khaos.gaywidth), y = v.RandomRange(-32, -64), xoffset = 0, xdir = 1, frame = 1}
        if v.RandomChance(FRACUNIT/399) then
            snable.pichu = true -- :3c
        else
            if player.khaossp.drowned and v.RandomChance(FRACUNIT/500) then
                snable.skull = true
            end
        end
        table.insert(v.khaos.animator, snable)
        -- x = v.RandomRange(1, v.khaos.gaywidth), y = v.RandomRange(-32, -64)

    end

    for index, value in ipairs(v.khaos.animator) do
        local spritertable = ConfettiTable[value.spr]
        if value.pichu then
            spritertable = RareConfetti
        elseif value.skull then
            spritertable = RareConfettiTWO
        end
        local framer = spritertable[value.frame]


        if (leveltime % 5 == 0) or value.pichu or value.skull then
            value.frame = $ + 1
        end

        if value.frame > #spritertable then
            value.frame = 1
            value.xdir = -$
        end

        if value.frame == #spritertable / 2 then
            value.xdir = -$
        end

        if value.xdir == 1 then
            value.xoffset = $ + 1
        else
            value.xoffset = $ - 1
        end

        value.y = $ + 1

        v.draw(value.x+value.xoffset, value.y, v.cachePatch(framer))


        if value.y > v.khaos.gayheight + 32 then
            table.remove(v.khaos.animator, index)
        end
    end

end

local function ipadkid(v, player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos then return end
    if not SRB2CE_Enabled return end
    if mapheaderinfo[gamemap].srb2cecity then return end
    v.khaos.Smooth = v.khaos.Smooth or 20

    v.khaos.gaywidth = v.width()/v.dupx() -- true width without multipler
    v.khaos.gayheight = v.height()/v.dupy() -- true height without multipler
    --320, 200
    --384, 216
    v.khaos.x = 0
    v.khaos.y = 0
    if v.khaos.gaywidth != 320 or v.khaos.gayheight != 200 then -- different resolution, account for this
        v.khaos.x = 320 - v.khaos.gaywidth
        v.khaos.y = (200 - v.khaos.gayheight)/2 -- ??? why though
    end

    if (leveltime % 2) == 0 then -- makes this slightly slower as to be more perceptible. making it too slow just makes it look bad though
        if player.khaos.ipadkid then
            if v.khaos.Smooth > 1 then
                v.khaos.Smooth = $ - 1
            end
        else
            if v.khaos.Smooth < 20 then
                v.khaos.Smooth = $ + 1
            end
        end
    end

    if v.khaos.Smooth != 20 then
        v.drawFill(v.khaos.x, v.khaos.y, (v.khaos.gaywidth/3)/v.khaos.Smooth, v.khaos.gayheight)
        v.drawFill(v.khaos.gaywidth - (v.khaos.gaywidth/3)/v.khaos.Smooth, v.khaos.y, (v.khaos.gaywidth/3)/v.khaos.Smooth, v.khaos.gayheight) -- there doesn't seem to be any non-horrificily jank way to make this work consistently across aspect ratios. so fuck it, i'm not doing that!
    end
end

local function kittyrat(v, player)
    if not v.khaos then v.khaos = {} end
    if not player.khaos.animaltime then v.khaos.krinit = false return end

    local width = v.width()/v.dupx() -- true width without multipler
    local height = v.height()/v.dupy() -- true height without multipler

    local animals = -- all of these will be 160 in height
    {{"KH_CAT", 127},
    {"KH_RAT", 141},
    {"KH_BIRD", 161},
    {"KH_DOG", 133},
    {"KH_POSS", 103}
    }

    if v.RandomChance(FRACUNIT/4) or SRB2CE.AmplifyChecker(player) then -- rarer because the rabbit is fucking huge
        table.insert({"KH_BUNY", 190}, -- you can actually see the watermark in this one lol
        animals)
    end

    if not v.khaos.krinit then
        v.khaos.kry = 160
        v.khaos.kanimal1 = v.RandomRange(1, #animals)
        v.khaos.kanimal2 = v.RandomRange(1, #animals)
        v.khaos.krinit = true
    end

    v.khaos.kry = max($ - 7, 0)

    v.draw(animals[v.khaos.kanimal1][2], height-160 + v.khaos.kry, v.cachePatch(animals[v.khaos.kanimal1][1]), V_SNAPTOLEFT|V_SNAPTOTOP|V_FLIP) -- left
    v.draw(width-animals[v.khaos.kanimal2][2], height-160 + v.khaos.kry, v.cachePatch(animals[v.khaos.kanimal2][1]), V_SNAPTOLEFT|V_SNAPTOTOP) -- right
end

-- layer order, top of the list is the back, bottom is the front
hud.add(timerhud, "game")
hud.add(khaostext, "game")
hud.add(khaos, "game")
hud.add(darkvisionhud, "game")
hud.add(borkscreen, "game")
hud.add(dvdhud, "game")
hud.add(yourewinner, "game")
hud.add(ipadkid, "game")
hud.add(textboxhud, "game")
hud.add(kittyrat, "game")
