--[[ SRB2: Chaotic Edition v2
Single Player Content Script
]]

local goodeffectworth = 4
local neutraleffectworth = -3
local badeffectworth = -8

--[[GOALS:
    - Make a menu system to interact with the shop, options, and Fang's missions.
        - Overhaul the Blacklist system, make it a menu to toggle effects on and off.
    - Have a pop-up system for notifications.
        - Have an "achievement" system with pop-ups.
        - Make unlockables a thing, using the same pop-up system to show when you've unlocked something.
            - i.e. Breaking Tails' laptop screen will give you an unlockable khaos effect.
]]

--[[ Menu Interface
    - Style it after MMT's menu interface, but have a focus on icons being allowed.
        - Have a set number of slots that the interface takes (like, 9 for example). Then just fill the slot with the relevant items.
        - Use a multiplier for pages.
        - Also, utilizing this, maybe have menu items take up like, actual physical pages on a UI? That'd be kinda cute for the catalog.
    - Shop system will have a money back at a corner of the screen, with total amount of rings saved there.

]]

local function InitKhaosSP(player)
    player.khaosmenu = {}
    player.khaossp = {}
    --player.khaossp.playerpoints = $ or 0
    --player.khaossp.botpoints = $ or 0
    player.khaossp.bank = 0
    player.khaossp.multiplier = 100 -- hello everyone my name is
    player.khaossp.basemulti = 100
    player.khaossp.delayload = (netgame and 35) or 6
    player.khaossp.khaosblacklist = {}
    player.khaossp.OptionsLoadAmount = 1
    player.khaossp.OptionsErrors = 0
    player.khaossp.toload = 0
    player.khaossp.warpcooldown = 2 * TICRATE
end


local TB = CFTextBoxes -- shortcut

local function ReplaceMobj(mobj, replacer)
    mobj.type = replacer
    local replacer = mobjinfo[replacer]
    mobj.state = replacer.spawnstate or $
    mobj.health = replacer.spawnhealth or $
    mobj.reactiontime = replacer.reactiontime or $
    mobj.radius = replacer.radius or $
    mobj.height = replacer.height or $
    mobj.dispoffset = replacer.dispoffset or $
    mobj.mass = replacer.mass or $
    mobj.flags = replacer.flags or $
end

local function BootlegAttract(mo, target, speed, xoffs, yoffs, zoffs) -- originated from tatsuru's conversion of SRB2 source code
    xoffs = $ or 0
    yoffs = $ or 0
    zoffs = $ or 0

    local newx = target.x + xoffs
    local newy = target.y + yoffs
    local newz = target.z + zoffs
    local dist = R_PointToDist2(0, 0, R_PointToDist2(mo.x, mo.y, newx, newy), newz - mo.z)

    if speed < dist
        mo.momx = FixedMul(FixedDiv(newx - mo.x, dist), speed)
        mo.momy = FixedMul(FixedDiv(newy - mo.y, dist), speed)
        mo.momz = FixedMul(FixedDiv(newz - mo.z, dist), speed)
    elseif speed > dist
        mo.momx = 0
        mo.momy = 0
        mo.momz = 0
        local CoolTeleFunction = P_TeleportMove
        if P_SetOrigin then -- new function for interpolation mod; don't use it if it doesn't exist
            CoolTeleFunction = P_SetOrigin
        end
        CoolTeleFunction(mo, newx, newy, newz)
    end
end

local function fancymultiplier(number)
    local finalnumber
    finalnumber = number / 100

    if finalnumber != 0 then
        local extra = (number % 100 < 10 and "0") or ""
        finalnumber = tostring($) + "." + extra + tostring(number % 100)
    else
        local extra = (number < 10 and "0") or ""
        finalnumber = "0." + extra + tostring(number)
    end

    return finalnumber
end

local function CheckClone(skin)
    local TheTruth = false -- this says alot about our Society....
    for player in players.iterate do
        if player.mo and player.mo.valid and player.mo.skin == skin then
            TheTruth = true
        end
    end

    return TheTruth
end

local function sortByKey(key)
    return function(a, b)
        return a[key] < b[key]
    end
end

local function indexOfName(array, value) --thanks to amperbee for telling me the obvious that i can just modify this function lol
    for i, v in ipairs(array) do
        if v.name == value then
            return i
        end
    end
    return nil
end

local ANGLE_REAL_MAX = 4294967295 -- for some reason, ANGLE_MAX doesn't actually work, so i have to do this, thanks stjr

addHook("MobjThinker", function(clock)
    clock.momz = 0
    local hour = 3
    local minute = 22
    local second = 44
    if players[0].khaossp.repairclock then
        hour, minute, second = os.date("%I"), os.date("%M"), os.date("%S")
    end

    if clock.state == S_KHAOSCLOCK1 then
        local time = hour*2
        local divider = (ANGLE_REAL_MAX)/12
        clock.rollangle = divider*time
    elseif clock.state == S_KHAOSCLOCK2 then
        local time = minute*2
        local divider = (ANGLE_REAL_MAX)/60
        clock.rollangle = divider*time
    elseif clock.state == S_KHAOSCLOCK3 then
        local time = second*2
        local divider = (ANGLE_REAL_MAX)/60
        clock.rollangle = divider*time
    end
        --os.date("%M")
        --os.date("%S")
end, MT_KHAOSCLOCK)

addHook("MobjThinker", function(floatingthing)
    floatingthing.skin = "amy"
    floatingthing.color = SKINCOLOR_ROSY
    floatingthing.shadowscale = FRACUNIT
    if CheckClone("amy") then -- make this a clone
        floatingthing.color = SKINCOLOR_SILVER
        --floatingthing.colorized = true
    end
    --floatingthing.colorized = true

    --floatingthing.angle = (spintimer*180)*FRACUNIT
    --floatingthing.frame = $1 | TR_TRANS40
end, MT_KHAOSAMY)

addHook("MobjThinker", function(floatingthing)
    floatingthing.skin = "knuckles"
    floatingthing.color = SKINCOLOR_RED
    floatingthing.shadowscale = FRACUNIT
    if CheckClone("knuckles") then -- make this a clone
        floatingthing.color = SKINCOLOR_SILVER
        --floatingthing.colorized = true
    end
    --floatingthing.colorized = true

    --floatingthing.angle = (spintimer*180)*FRACUNIT
    --floatingthing.frame = $1 | TR_TRANS40
end, MT_KHAOSKNUX)

addHook("MobjThinker", function(floatingthing)
    floatingthing.skin = "metalsonic"
    floatingthing.color = SKINCOLOR_COBALT

    if CheckClone("metalsonic") then -- make this a clone
        floatingthing.color = SKINCOLOR_SILVER
        --floatingthing.colorized = true
    end

    if not floatingthing.activateme then
        floatingthing.alpha = 0
    else
        floatingthing.alpha = FRACUNIT
        floatingthing.shadowscale = FRACUNIT
    end
    --floatingthing.colorized = true

    --floatingthing.angle = (spintimer*180)*FRACUNIT
    --floatingthing.frame = $1 | TR_TRANS40
end, MT_KHAOSMETAL)


addHook("MobjThinker", function(floatingthing)
    floatingthing.skin = "fang"
    floatingthing.color = SKINCOLOR_LAVENDER
    floatingthing.shadowscale = FRACUNIT
    if CheckClone("fang") then -- make this a clone
        floatingthing.color = SKINCOLOR_SILVER
    end

end, MT_KHAOSFANG)

addHook("MobjThinker", function(floatingthing)
    floatingthing.skin = "tails"
    floatingthing.color = SKINCOLOR_ORANGE
    if CheckClone("tails") then -- make this a clone
        floatingthing.color = SKINCOLOR_SILVER
        --floatingthing.colorized = true
    end
    floatingthing.shadowscale = FRACUNIT
    if not floatingthing.spawnedtails
        floatingthing.tailsy = P_SpawnMobj(floatingthing.x, floatingthing.y, floatingthing.z, MT_KHAOSFIGTLS)
        floatingthing.tailsy.skin = floatingthing.skin
        floatingthing.tailsy.angle = floatingthing.angle
        floatingthing.tailsy.color = floatingthing.color
        floatingthing.tailsy.colorized = floatingthing.colorized
        floatingthing.tailsy.tics = 1
        floatingthing.spawnedtails = true
        --floatingthing.thrusttimer = 3
    end
    --[[floatingthing.thrusttimer = $ -1
    if floatingthing.thrusttimer == 0 -- P_Move
        P_InstaThrust(floatingthing.tailsy, floatingthing.angle, 0)
    end]]

    --floatingthing.angle = (spintimer*180)*FRACUNIT

    -- [[ the tails ]] --
    floatingthing.tailsy.angle = floatingthing.angle
    floatingthing.xmove = floatingthing.x + P_ReturnThrustX(floatingthing.tailsy, floatingthing.tailsy.angle, FixedMul(-1*FRACUNIT, floatingthing.tailsy.scale)) -- stole this from SRB2's source code lol
    floatingthing.ymove = floatingthing.y + P_ReturnThrustY(floatingthing.tailsy, floatingthing.tailsy.angle, FixedMul(-1*FRACUNIT, floatingthing.tailsy.scale))
    P_MoveOrigin(floatingthing.tailsy, floatingthing.xmove, floatingthing.ymove, floatingthing.tailsy.z)

    --floatingthing.frame = $1 | TR_TRANS40
    --floatingthing.tailsy.frame = $1 | TR_TRANS40
end, MT_KHAOSTAILS)

local FINEANGLES = 8192
local FINEMASK = FINEANGLES - 1
local ANGLETOFINESHIFT = 19

local function FakeRingBurst(actor, var1, var2, var3) -- use var2 for amount of time to collect rings, if set to 0 it's 8 seconds, the default amount;
    --[[if var2
        S_StartSound(actor.tracer, sfx_sttb3)
    else
        S_StartSound(actor, sfx_s3kb9)
    end]]

    if not var2 var2 = 8 end

    local i
    local mo
    local fa, va
    local ns
    local z
    local nightsreplace = ((maptol & TOL_NIGHTS) and not G_IsSpecialStage(gamemap))

    -- Better safe than sorry.
    if not actor
        --print("no actor!")
        return
    end

    if (var1 > 32)
        var1 = 32
    end

    if (abs(actor.momx) > actor.scale or abs(actor.momy) > actor.scale)
        va = R_PointToAngle2(actor.momx, actor.momy, 0, 0)>>ANGLETOFINESHIFT
    else
        va = actor.angle>>ANGLETOFINESHIFT
    end

    for i = var1, 1, -1 do
        --print("gamer " .. i)
        local objType = MT_KHAOSFAKERING

        z = actor.z
        if (actor.eflags & MFE_VERTICALFLIP)
            z = $ + (actor.height - mobjinfo[objType].height)
        end

        mo = P_SpawnMobj(actor.x, actor.y, z, objType)

        mo.fuse = var2*TICRATE
        mo.target = actor

        if var3 then
            mo.target = var3
            mo.endspawn = true
        end

        mo.destscale = actor.scale
        mo.scale = actor.scale

        -- Angle offset by player angle, then slightly offset by amount of rings
        --fa = ((i*FINEANGLES/16) + va - ((var1-1)*FINEANGLES/32)) & FINEMASK
        fa = (((i*FINEANGLES/16) + va - ((var1-1)*FINEANGLES/32)) & FINEMASK) * ANG1

        -- Make rings spill out around the player in 16 directions like SA, but spill like Sonic 2.
        -- Technically a non-SA way of spilling rings. They just so happen to be a little similar.
        local momxy
        local momz -- base horizonal/vertical thrusts

        if (i > 15)
            momxy = 3*FRACUNIT
            momz = 4*FRACUNIT
        else
            momxy = 2*FRACUNIT
            momz = 3*FRACUNIT
        end

        if var3 then
            momxy = $ + P_RandomRange(-1, 3)*FRACUNIT + P_RandomFixed()
            momz = $ + P_RandomRange(-1, 2)*FRACUNIT + P_RandomFixed()
            fa = $ + (P_RandomRange(-3, 3) * ANG1)
        end

        ns = FixedMul(FixedMul(momxy, FRACUNIT + FixedDiv((TICRATE/2)<<FRACBITS, 10*TICRATE<<FRACBITS)), mo.scale)
        mo.momx = FixedMul(cos(fa),ns)
        mo.color = SKINCOLOR_PINK
        if P_RandomChance(FRACUNIT/4) then
            mo.color = SKINCOLOR_RUBY
        end
        if P_RandomChance(FRACUNIT/4) then
            mo.color = SKINCOLOR_ROSY
        end
        if P_RandomChance(FRACUNIT/4) then
            mo.color = SKINCOLOR_CHERRY
        end

        if (not twodlevel or (actor.flags2 & MF2_TWOD))
            mo.momy = FixedMul(sin(fa),ns)
        end

        ns = FixedMul(momz, FRACUNIT + FixedDiv((TICRATE/2)<<FRACBITS, 10*TICRATE<<FRACBITS))
        P_SetObjectMomZ(mo, ns, false)

        if (i & 1)
            P_SetObjectMomZ(mo, ns, true)
        end
    end

    if (actor.eflags & MFE_VERTICALFLIP)
        mo.momz = $ * -1
    end

    return
end

local function PointPlayer2NPC(player, npc)
    local point2
    local m = player.realmo
    local range = 178*FRACUNIT -- might need to bump it up a lil bit
    player.pflags = $|PF_FULLSTASIS -- text box library takes a tic to actually give the player full stasis, that's long enough for the angle to change again!
    searchBlockmap("objects", function(ref, found)
        if found.type == npc then
            player.drawangle = R_PointToAngle2(m.x, m.y, found.x, found.y)
        end
    end, m, m.x-range, m.x+range, m.y-range, m.y+range)
end


local function tablelength(T) --needed for tables w/ keys and values, for some reason.
local count = 0
for _ in pairs(T) do count = count + 1 end
return count
end

local intnametable = {} -- all things that can be saved go in here. it goes key = internal name, value = full name (shows up in stuff like help, and maybe statistics)
rawset(_G, "khaos_intnametable", intnametable)

local function searchoptionstable(name)
    for key, value in pairs(SRB2CE.optionstableofdoom) do
        if value.name == name then
            return value
        end
    end
end

local function has_value(tab, val)
    for index, value in ipairs(tab) do
        if value == val then
            return true
        end
    end

    return false
end

local function deepcopy(o, seen)
  seen = seen or {}
  if o == nil then return nil end
  if seen[o] then return seen[o] end

  local no
  if type(o) == 'table' then
    no = {}
    seen[o] = no

    for k, v in next, o, nil do
      no[deepcopy(k, seen)] = deepcopy(v, seen)
    end
    setmetatable(no, deepcopy(getmetatable(o), seen))
  else -- number, string, boolean, etc
    no = o
  end
  return no
end


local function addMenu(name, tbl)
    table.sort(tbl, sortByKey("order"))
    Khaos_ListOMenus[name] = tbl
    for key, value in pairs(tbl) do
        if type(value) == "table" then
            if value.intname then
                intnametable[value.intname] = deepcopy(value)
                --table.insert(SRB2CE.items2save, value.intname) --TODO: manually add all this stuff instead, just to make sure nothing gets out of order post-launch
            end
        end
    end
end

addMenu("unlocks", -- this isn't actually a menu, this is to handle unlocks that you can't buy, i.e. achievements and the such, just to show their names
{
    {
        order = 1,
        name = "Meet (Fang) the Sniper",
        hidename = true,
        savereq = {"hunter"},
        intname = "reenterhunter",
    },
    {
        order = 2,
        name = "Worst Friend",
        description = "Annoy Amy.",
        intname = "annoyingfriend",
        graphic = "KH_AMYWOW",
    },
    {
        order = 3,
        name = "Screen Breaker",
        description = "Smash Tails' laptop, because you're evil.",
        intname = "brokenscreen",
        graphic = "KH_CRCKSCRN",
    },
    {
        order = 4,
        name = "Ring Bag",
        description = "There's a hidden bag somewhere in Chaos City...",
        intname = "ringbag",
        xoffset = 5,
        yoffset = 1,
        graphic = "KH_RINGBAG1"
    },
    {
        order = 5,
        name = "Death",
        description = "Find some way to die in Chaos City.",
        intname = "drowned",
        graphic = "KSKULL_",
        scale = 4,
        animated = true,
        speed = 2,
        frames = 24,
        hidename = true,
        savereq = {"drowned"}, -- lol
    },
    {
        order = 6,
        name = "Pong Master",
        description = "Win 10 games of pong!", -- was 15 but it's 10 now solely because if some poor soul tries to speedrun this, 10 is less agonizing than 15 lol
        intname = "pongmaster",
        graphic = "KH_PONGM",
    }
})

addMenu("khaosmenu",
{
    {
        order = 1,
        name = "Keep Rings on Hit",
        description = "Every time you get hit, keep half of your rings!",
        intname = "ringkeep",
        price = 25,
        graphic = "KH_RINGBAGG",
    },
    {
        order = 2,
        name = "FX Pax 1",
        description = "Cheap starter pack of nice effects!",
        intname = "fxpax1", -- internal name, used for save file purposes. can also be used by effects to "unlock" themselves for use.
        price = 50, -- rings it costs, duh
        graphic = "KH_FXPAX1",
    },
    {
        order = 3,
        name = "FX Pax 2",
        description = "Contains a variety of effects, mostly helpful ones!",
        --description2 = "you have on, the more rings you get!",
        intname = "fxpax2", -- effects will be tagged with "unlock", and will detect for this string being in the save file
        price = 100,
        graphic = "KH_FXPAX2",
    },
    {
        order = 4,
        name = "Universal Effects", --? maybe rename this?
        description = "Harnessing Tails' technology, every 30 seconds, a big effect gets rolled,",
        description2 = "which can change a lot. Increases Ring Multiplier by x0.2.",
        intname = "universalfx",
        graphic = "KH_TKK",
        scale = 4,
        price = 200,
    },
    --[[{
        order = 5,
        name = "Emergency Effect (NOTHING DONE)",
        intname = "emergency",
        description = "Assign an effect with Tails to have an",
        description2 = "effect you can use once per purchase.",
        price = 200,
        graphic = "KH_SAFETY"
    },]]
    {
        order = 5,
        name = "Rigged Dice",
        description = "Increases the odds of good effects, and decreases",
        description2 = "the chances of bad effects.",
        intname = "rdice",
        price = 300,
        graphic = "KDICE_",
        animated = true,
        speed = 3,
        frames = 10
    },
    {
        order = 6,
        name = "On-start Effect",
        intname = "starteffect",
        description = "Talk to Tails to assign an effect that's",
        description2 = "applied at the start of any level.",
        price = 400,
        graphic = "KSPARK",
        animated = true,
        frames = 11,
        speed = 2,
    },
    {
        order = 7,
        name = "Amplifier",
        description = "Allows for 'Amplified Mode', to make all effects more",
        description2 = "potent, good or bad. Increases Ring Multiplier by 0.25.",
        intname = "amplifier",
        price = 300,
        graphic = "KH_AMPLIFIER"
    },
    --[[{
        order = 7,
        name = "Double Or Nothing (NOTHING DONE)",
        description = "Whenever you enter the next level, you're given",
        description2 = "a random chance to double your previous earnings.",
        --how this works is, the earnings from your last level aren't deposited yet. if you accept it, they get put into your current ring count, and your ring multiplier increases by 1.
        intname = "doubleornothing",
        --price = 500,
        graphic = "KH_TEMP"
    },]]
    {
        order = 8,
        name = "Keep More Rings",
        savereq = {"ringkeep"},
        description = "When you get hit, you get to keep more of your rings",
        description2 = "than you were previously able to. 2/3 rings are kept!",
        --how this works is, the earnings from your last level aren't deposited yet. if you accept it, they get put into your current ring count, and your ring multiplier increases by 1.
        intname = "keepmorerings",
        price = 300,
        graphic = "MONEY_",
        xoffset = 2,
        animated = true,
        speed = 2, -- the higher the slower
        frames = 18
    },

    type = "shop",
    name = "Chaos Catalog",
    --maxitems = 7
})

addMenu("randomizermenu", -- maybe make this the wheels of fate?
{
    {
        order = 1,
        name = "Randomizer (ALL INCOMPLETE)",
        description = "Adds a randomizer mode, which changes",
        description2 = "many aspects of the levels around!",
        intname = "randomizer",
        --price = 250,
        graphic = "KH_RANDOMIZER",
    },
    {
        order = 2,
        name = "Enemies",
        description = "Randomize all the enemies on the map!",
        intname = "renemies",
        graphic = "KH_TEMP",
        savereq = {"randomizer"},
        --price = 300
    },
    {
        order = 3,
        name = "Textures",
        description = "Randomize the textures all over the map!",
        intname = "rtextures",
        graphic = "KH_TEMP",
        savereq = {"randomizer"},
        --price = 300
    },
    {
        order = 4,
        name = "Enemies Pack 1",
        description = "Add more enemies to be thrown in randomly!",
        requires = "renemies", -- requires this to be unlocked first
        intname = "erand1",
        graphic = "KH_TEMP",
        savereq = {"randomizer", "renemies"},
        --price = 500
    },
    {
        order = 5,
        name = "Random Objectives",
        description = "On the start of random levels, satisfy random",
        description2 = "objectives before the time runs out to get bonus rings!",
        intname = "objective",
        graphic = "KH_TEMP",
        savereq = {"randomizer"},
        --price = 500
    },

    type = "shop",
    name = "Randomizer Catalog",
})


addMenu("miscmenu",
{
    {
        order = 1,
        name = "Gamblecore",
        description = "Every time a new effect gets rolled,", -- this will also delay the time it takes for effects to actually get applied, just so the voice clip doesn't get cut off.
        description2 = "you hear 'LET'S GO GAMBLING!'",
        graphic = "KH_GAMBLECORE",
        intname = "gamblecore",
        price = 200
    },
    {
        order = 2,
        name = "Timer Bar Colors",
        description = "The timer bar can now glow with",
        description2 = "rainbow colors, or be your color!",
        intname = "timerbarcolors",
        graphic = "KH_COLOR",
        price = 150
    },
    {
        order = 3,
        name = "Custom Text Borders",
        description = "Change up the borders to the text that",
        description2 = "shows up when you get new effects!",
        intname = "hudtextborder",
        graphic = "KH_TXT",
        price = 100
    },

    type = "shop",
    name = "Misc. Catalog",
})

addMenu("townshop",
{
    {
        order = 1,
        name = "Master Emerald Protector 5000",
        description = "Protect the Master Emerald, so you can convince",
        description2 = "Knuckles to join!",
        intname = "knuckles",
        graphic = "KH_SENTRY",
        price = 200
    },
    {
        order = 2,
        name = "Hunter's Contract",
        description = "Convince Fang to move into town! He won't do much just yet though...",
        intname = "hunter", -- unlocks omochao; lore is that omochao was trapped in the roof. have amy comment on this
        graphic = "KH_HUNTER",
        price = 350
    },
    {
        order = 3,
        name = "City Decoration", -- so far this only affects the bushes in the park
        description = "Pretty up the city! This will permanently increase",
        description2 = "the Ring Multiplier by x0.2.",
        intname = "prettycity",
        graphic = "KH_PRETTY",
        price = 500
    },
    {
        order = 4,
        name = "Repair Clock",
        description = "Repairs the giant clock on the tower!",
        description2 = "This can tell your real system time!",
        intname = "repairclock",
        graphic = "KH_CLOCK",
        --savereq = {"prettycity"},
        price = 250
    },
    {
        order = 5,
        name = "Fix The Shop's Roof",
        description = "Fang's such a... give Amy enough to get her",
        description2 = "roof back! Increases Ring Multiplier by x0.15",
        intname = "amyroof",
        savereq = {"hunter", "reenterhunter"},
        graphic = "KH_HOME",
        hidename = true,
        price = 400
    },
    {
        order = 6,
        name = "Arcade Machine Repair",
        intname = "arcade",
        description = "Fix that arcade machine in the corner. Who knows",
        description2 = "what's actually on it?",
        graphic = "KH_REPAIR",
        price = 2000
    },

    --[[    {
        order = 2,
        name = "Mysterious Cartridge",
        description = "Why the heck is this so huge?",
        intname = "baseballminigame",
        graphic = "KH_TEMP",
        hidename = true,
        savereq = {"pongmaster"},
        price = 1000
    },]]


    type = "shop",
    name = "Town Catalog",
})

    --[[{
        order = 4,
        name = "Cassette Tapes",
        description = "Characters have new music tracks that",
        description2 = "can be played when interacting with them.",
        intname = "tapes",
        price = 500
    },]]

addMenu("catalogsmenu",
{
    {
        order = 1,
        name = "Chaos",
        description = "Adjusts your Chaos experience!",
        graphic = "KH_RDICE",
        table = "khaosmenu"
    },
    --[[{
        order = 2,
        name = "Randomizer (COMING SOON!)",
        --description = "a",
        --table = "randomizermenu",
        graphic = "KH_RANDOMIZER",
    },]]
    {
        order = 2,
        name = "Town Shop",
        --description = "a",
        graphic = "KH_HOME",
        table = "townshop"
    },
    {
        order = 3,
        name = "Misc. Items",
        --description = "a",
        graphic = "KH_MISC",
        table = "miscmenu"
    },
    type = "catalog",
    name = "Catalogs"
})

local function constructunlocksmenu()
    --TODO: add sub-menus that tells you what effects these can unlock for you
    local thetable = {type = "unlockstatistics", name = "Unlocks",}
    local indexer = 0
    for index, value in ipairs(SRB2CE.items2save) do
        if not value[3] then
            indexer = $ + 1
            local thinger = deepcopy(intnametable[value[1]])
            local insertion = thinger or {name = "INVALID! FIX ME!"} -- get the table
            insertion.order = indexer
            insertion.savevalue = value[1]
            table.insert(thetable, insertion)
        end
    end

    addMenu("unlockstatistics", thetable)
end

constructunlocksmenu()

addMenu("genstatistics",
{
    {
        order = 1,
        name = "Time Spent",
        savevalue = "ktimespent",
        graphic = "KH_CLOCK",
        description = "How much time have you spent in Chaotic Edition?",
        description2 = "(only counts up in levels outside of Chaos City)",
        type = "timer",
    },
    {
        order = 2,
        name = "Chaos Rings collected",
        savevalue = "kringscollected",
        graphic = "KH_RINGBAGG",
        description = "This is how many rings you've bagged!",
    },
    {
        order = 3,
        name = "Pain Inflicted during Chaos",
        savevalue = "timeshitbykhaos",
        graphic = "KSKULL_",
        scale = 4,
        animated = true,
        speed = 2,
        frames = 24,
        description = "How long have you spent reeling in pain while ",
        description2 = "chaos is active?",
        type = "timers",
    },

    type = "statistics",
    name = "General Statistics",
})

addMenu("statisticsmenu",
{
    {
        order = 1,
        name = "Chaos FX Info",
        description = "What's with all these chaos effects? Here's the info!",
        table = "chaosinfo"
    },
    {
        order = 2,
        name = "General Statistics",
        description = "How has chaos affected you overall?",
        table = "genstatistics",
    },
    {
        order = 3,
        name = "Unlocks",
        description = "What have you unlocked so far?",
        description2 = "%UNLOCKPERC",
        table = "unlockstatistics"
    },
    type = "catalog",
    name = "Chaos Information"
})



addMenu("mainoptions",
{
    {
        order = 1,
        name = "Enable Chaos",
        command2change = "SRB2CE_Enabled",
        graphic = "KH_RDICE",
        description = "This is the core of the mod; disable this if",
        description2 = "you're in a server and don't want to unload.",
        admin = true,
        type = "boolnum",
    },
    {
        order = 2,
        name = "HUD",
        command2change = "SRB2CE_HUD",
        description = "Toggles the HUD on or off; turning it off",
        description2 = "provides an extra challenge!",
        graphic = "KH_HUD",
        type = "boolnum",
    },
    {
        order = 3,
        name = "HUD Position",
        command2change = "SRB2CE_HUD_Position",
        description = "Changes the position of your HUD!",
        optionnames = {"bottom", "top"},
        graphic = "KH_TWEAKUI",
        type = "boolnum",
    },
    {
        order = 4,
        name = "Timer Bar",
        command2change = "SRB2CE_HUD_Timer_Bar",
        description = "Toggles whether the timer bar is shown or not.",
        graphic = "KH_CLOCK",
        type = "boolnum",
    },
    {
        order = 5,
        name = "Change Music in Menus",
        command2change = "SRB2CE_Menu_Music",
        description = "Toggles whether the music changes when",
        description2 = "you go into menus.",
        graphic = "KH_MUSIC2",
        type = "boolnum",
    },


    type = "options",
    name = "Main Options",
    --maxitems = 6,
    --spacing = 17
})

addMenu("presskey",
{
    {
        order = 1,
        name = "Press Key",
        command2change = "$KEYPRESS",
        description = "This makes all effects more potent, good or bad, and enables",
        description2 = "some really bad effects. Increases Ring Multiplier by 0.25.",
        graphic = "KH_AMPLIFIER",
        type = "number",
    },
    type = "KEYPRESS",
    name = "Hold Spin for 3 seconds to go back!", -- TODO: that
})

addMenu("shoptions",
{
    {
        order = 1,
        name = "Keep Rings on Hit",
        savereq = {"ringkeep"},
        command2change = "SRB2CE_Ringkeep",
        description = "Whenever you get hit, you keep a fraction of",
        description2 = "your rings! Disable for 0.25x Ring Multiplier.",
        graphic = "KH_RINGBAGG",
        type = "boolnum",
    },
    {
        order = 2,
        name = "Amplified Mode",
        command2change = "SRB2CE_Amplify",
        savereq = {"amplifier"},
        description = "This makes all effects more potent, good or bad, and enables",
        description2 = "some really bad effects. Increases Ring Multiplier by 0.25.",
        admin = true,
        graphic = "KH_AMPLIFIER",
        type = "boolnum",
    },
    {
        order = 3,
        name = "Enable Universal Effects",
        command2change = "SRB2CE_Universal_Fx_Enabled",
        description = "Harnessing Tails' technology, after a set time, a big effect gets rolled, which can",
        description2 = "cause a lot to happen! Enabling increases the Ring Multiplier by 0.20.",
        graphic = "KH_TKK",
        scale = 4,
        savereq = {"universalfx"},
        admin = true,
        type = "boolnum",
    },
    {
        order = 4,
        name = "Universal Effects Timer",
        command2change = "SRB2CE_Universal_Timer",
        description = "Sets how long you have between",
        description2 = "Universal Effects!",
        savereq = {"universalfx"},
        graphic = "KH_CLOCK",
        values = searchoptionstable("SRB2CE_Universal_Timer").values,
        admin = true,
        type = "number",
    },
    {
        order = 5,
        name = "Universal Announcer",
        command2change = "SRB2CE_Universal_Announcer",
        description = "Changes what announcer is used for the Universal Effects!",
        -- description2 = "",
        graphic = "KH_VOICE",
        savereq = {"universalfx"},
        values = searchoptionstable("SRB2CE_Universal_Announcer").values,
        optionnames = {"Off", "S.A.M.", "Microsoft Sam"},
        admin = true,
        type = "number",
    },
    {
        order = 6,
        name = "Timer Bar Color",
        command2change = "SRB2CE_HUD_Timer_Color",
        description = "Changes the color of your timer bar! Player is",
        description2 = "your current color, rainbow is... rainbow!",
        optionnames = {"classic", "player", "rainbow"},
        savereq = {"timerbarcolors"},
        graphic = "KH_COLOR",
        values = searchoptionstable("SRB2CE_HUD_Timer_Color").values,
        type = "number",
    },
    {
        order = 7,
        name = "Gamblecore",
        command2change = "SRB2CE_Gamblecore",
        description = "LET'S GO GAMBLING!",
        graphic = "KH_GAMBLECORE",
        savereq = {"gamblecore"},
        type = "boolnum",
    },
    {
        order = 8,
        name = "On-start Effect",
        description = "Assign an effect that's applied at the start",
        description2 = "of any level, or checkpoint respawn!",
        savereq = {"starteffect"},
        graphic = "KSPARK",
        animated = true,
        speed = 2,
        frames = 11,
        table = "onstartmenu"
    },
    {
        order = 9,
        name = "Custom Text Borders",
        command2change = "SRB2CE_HUD_Text_Border_Type",
        description = "Changes what border is shown for text that shows up!",
        -- description2 = "",
        graphic = "KH_TXT",
        savereq = {"hudtextborder"},
        values = searchoptionstable("SRB2CE_HUD_Text_Border_Type").values,
        optionnames = {"Default", "TTK", "Round", "Tri"},
        admin = true,
        type = "number",
    },


    type = "options",
    name = "Shoptions",
})


-- constructing blacklistmenu; this was done mainly for mod support, and also because this lua script runs before the actual khaos script

local function constructblacklistmenu()
    local thetable1 = {type = "blacklist", name = "Toggle Effects",}
    local thetable2 = {type = "starteffect", name = "On-start Effect",}
    local thetable3 = {type = "chaosinfo", name = "Chaos FX Info",}
    local indexer1 = 0
    local indexer2 = 0
    local indexer3 = 0
    for key, value in pairs(KhaosEffectsTable) do
        local insertion = {
            --order = indexer,
            name = value.name,
            savereq = {value.savereq},
            hidename = value.hidename,
            key = key,
            description = value.description,
            description2 = value.description2,
            --if #value.description > 50 then --and split this on the space
            graphic = value.sprite,
            xoffset = 2,
            yoffset = 1,
            graphic2 = (value.etype == "good" and "KH_GOOD") or (value.etype == "bad" and "KH_BAD") or (value.etype == "bees" and "KH_BEEBORDER") or "KH_NEUTRAL",
            --xoffset2 = 6,
            yoffset2 = -1,
            scale = 1,
            scale2 = 1,
        }
        if not value.noblacklist then
            indexer1 = $ + 1
            insertion.order = indexer1
            table.insert(thetable1, deepcopy(insertion)) -- doing a deepcopy to ensure we don't get interfered by changing the order next time
        end
        if not value.startexception then
            indexer2 = $ + 1
            insertion.order = indexer2
            table.insert(thetable2, deepcopy(insertion))
        end
        if true then -- lol. lmao.
            indexer3 = $ + 1
            insertion.order = indexer3
            insertion.table = "KH_" + key --TODO: construct menu for this
            table.insert(thetable3, deepcopy(insertion))
        end

        -- now we do ungodly horrors. let's hope we don't fuck up the memory usage doing this!
        -- ... i am so sorry for this.
        local indexer4 = 1
        local khinfometa = {type = "fxinfo", name = "Effect Info"}
        local khinfo = {
            name = value.name,
            savereq = {value.savereq},
            hidename = value.hidename,
            key = key,
            order = 1,
            description = value.description,
            description2 = value.description2,
            --if #value.description > 50 then --and split this on the space
            graphic = value.sprite,
            xoffset = 2,
            yoffset = 1,
            graphic2 = (value.etype == "good" and "KH_GOOD") or (value.etype == "bad" and "KH_BAD") or (value.etype == "bees" and "KH_BEEBORDER") or "KH_NEUTRAL",
            --xoffset2 = 6,
            yoffset2 = -1,
            scale = 1,
            scale2 = 1,
        }

        local Duration = (value.duration < 0 and "Infinite")
        or (value.duration == 1 and tostring(value.duration) + " second")
        or (value.duration > 1 and tostring(value.duration) + " seconds")
        or "Instant"

        if value.duration > 0 and value.range then
            local mintime = max(value.duration - (value.range/3), value.duration/2 + 1) -- done to prevent effect from going under half it's time
            local maxtime = value.duration + (value.range + 2)
            Duration = mintime + "-" + maxtime + " seconds"
        end

        local Additioneer
        if value.addition then
            local secondman = " second"
            local lengthener = " more"
            if abs(value.addition) > 1 then
                secondman = " seconds"
            end
            if value.addition < 0 then
                lengthener = " less"
            end
            Additioneer = abs(value.addition) + secondman + lengthener
        end

        indexer4 = $ + 1
        table.insert(khinfometa,
        {
            name = "Duration",
            description = Duration,
            description2 = Duration != "Instant" and value.range and "This effect will have a randomized timer, using this as the min/max values.",
            order = indexer4,
            graphic = "KH_CLOCK",
        }
        )

        if Additioneer then
            indexer4 = $ + 1
            table.insert(khinfometa,
            {
                name = "Additional time in Amplify Mode",
                description = Additioneer,
                order = indexer4,
                graphic = "KH_AMPLIFIER",
            }
            )
        end

        if value.savereq then
            indexer4 = $ + 1
            table.insert(khinfometa,
            {
                name = "Unlocked by:",
                description = intnametable[value.savereq].name,
                order = indexer4,
                graphic = intnametable[value.savereq].graphic,
            }
            )
        end


        local checkers = {{"amplifyname", "Amplified Name"}, {"ignoremultiplier", "Disabling does not affect the Ring Multiplier.", "KH_CHECKLIST", true}, {"immune2remove", "Unable to be removed by \"Remove Random Effect\"", "KH_CHECKLIST", true}, {"dontrollme", "Can't be rolled by the Roulette.", "KH_CHECKLIST", true}, {"nonights", "Can't be rolled in NiGHTs.", "KH_CHECKLIST", true}, {"nospecial", "Can't be rolled while in a special stage.", "KH_CHECKLIST", true}, {"nocart", "Can't be rolled while in a minecart.", "KH_CHECKLIST", true}, {"norock", "Can't be rolled while on a rolling rock.", "KH_CHECKLIST", true}, {"nonet", "Can't be rolled while in an online game.", "KH_CHECKLIST", true}, {"nobees", "Can't be rolled by \"You Get The Bees\".", "KH_CHECKLIST", true}, {"nobot", "Can't be rolled by a bot", "KH_CHECKLIST", true}, {"requirerings", "Player needs at least 1 ring for this to be rolled.", "KH_RINGBAGG", true}, {"amplifyonly", "Can only be rolled in Amplify Mode.", "KH_AMPLIFIER", true}} -- {"nobattle", "Can't be rolled while in a battle gamemode.", "KH_CHECKLIST", true}

        for key2, value2 in pairs(checkers) do
            if value[value2[1]] then
                indexer4 = $ + 1
                table.insert(khinfometa,
                {
                    name = value2[2],
                    description = (value2[4] and "") or value[value2[1]],
                    order = indexer4,
                    graphic = value2[3]
                }
                )
            end
        end

        if value.incompatible then
            --[[if indexer4 == 5 then -- add a blank one
                indexer4 = $ + 1
                table.insert(khinfometa,
                {
                    name = "",
                    order = indexer4,
                }
                )
            end]]
            indexer4 = $ + 1
            table.insert(khinfometa,
            {
                name = "-- INCOMPATIBLE EFFECTS START HERE --",
                description = "If you currently have one of these effects applied, then this effect will not",
                description2 = "apply. Conversely, you also can not get these effects while you have this.",
                order = indexer4,
                graphic = "KH_CRITICAL"
            }
            )
            for key2, value2 in pairs(value.incompatible) do
                indexer4 = $ + 1
                --print("v2: " + value2)
                local effectthing = KhaosEffectsTable[indexOfName(KhaosEffectsTable, value2)]
                table.insert(khinfometa,
                {
                    name = value2,
                    savereq = {effectthing.savereq}, -- if this is erroring out, one of the incompatible effects given doesn't exist!
                    hidename = effectthing.hidename,
                    order = indexer4,
                    description = "Incompatible with this!",
                    graphic = effectthing.sprite,
                    xoffset = 2,
                    yoffset = 1,
                    graphic2 = (effectthing.etype == "good" and "KH_GOOD") or (effectthing.etype == "bad" and "KH_BAD") or (effectthing.etype == "bees" and "KH_BEEBORDER") or "KH_NEUTRAL",
                    --xoffset2 = 6,
                    yoffset2 = -1,
                    scale = 1,
                    scale2 = 1,
                }
                )
            end
        end

        table.insert(khinfometa, deepcopy(khinfo))

        addMenu("KH_" + key, khinfometa)
    end

    addMenu("blacklistmenu", thetable1)
    addMenu("onstartmenu", thetable2) -- TODO: consider making it so selecting a bad effect increases your ring multiplier by a bit. choosing a good one doesn't affect it.
    addMenu("chaosinfo", thetable3)
end

addHook("ThinkFrame", function()
    if leveltime == 5  -- TASers are shocked by this! they need to wait 5 whole frames to use this menu!
        constructblacklistmenu()
    end

    if mapheaderinfo[gamemap].srb2cecity and (leveltime % TICRATE) == 0 then -- done just because i'm too lazy to prevent the player from using the pong machine til they come back
        if players[0].khaossp.arcade then
            P_LinedefExecute(106)
        end
    end

    if mapheaderinfo[gamemap].srb2cecity and leveltime == 10 then
        if players[0].khaossp.hunter then -- change map to account for fang
            P_LinedefExecute(6)
            if not players[0].khaossp.amyroof then
                P_LinedefExecute(34)
            end
        end
        if players[0].khaossp.knuckles then
            P_LinedefExecute(62)
        end
        if players[0].khaossp.arcade then
            P_LinedefExecute(106)
        end
        for mo in mobjs.iterate() do
            if mo.type == MT_TARGET then
                if players[0].khaossp.hunter then
                    ReplaceMobj(mo, MT_KHAOSFANG)
                else
                    mo.state = S_INVISIBLE
                    mo.flags = 0
                end
            end
            if mo.type == MT_PITY_BOX then
                if players[0].khaossp.knuckles then
                    ReplaceMobj(mo, MT_KHAOSKNUX)
                else
                    mo.state = S_INVISIBLE
                    mo.flags = 0
                end
            end
            if mo.type == MT_KHAOSRINGBAG then
                if players[0].khaossp.ringbag then
                    mo.state = S_INVISIBLE
                    mo.flags = 0
                end
            end
        end
        for mapthing in mapthings.iterate do
            if mapthing.type == 805 then
                mapthing.mobj.color = SKINCOLOR_FANCY
            end
            if mapthing.tag == 92 and not players[0].khaossp.prettycity then
                P_KillMobj(mapthing.mobj) --I FUCKING HATE NATURE!!!!
            end
        end
        if players[0].khaossp.prettycity then
            P_LinedefExecute(50) -- adjust various things, like fang's building
        else
            P_LinedefExecute(93) -- don't spawn water in the fountain
        end
    end
end)


addMenu("warp2chaoscity",
{
    {
        order = 1,
        name = "Warp To Chaos City",
        description = "Buy things, interact with NPCs, and more at",
        description2 = "Chaos City!",
        graphic = "KH_CHAOSCITY",
        warp = 1000,
        admin = true
    },
    name = "Press \x82" + "Jump\x80 to enter!",
    type = "warp"
})

addMenu("warpback",
{
    {
        order = 1,
        name = "Warp to Previous Level",
        description = "You're done in Chaos City? Go ahead n head back!",
        graphic = "KH_CHAOSCITY",
        warp = 6969,
        admin = true
    },
    name = "Press \x82" + "Jump\x80 to enter!",
    type = "warp"
})

addMenu("miscoptions",
{
    {
        order = 1,
        name = "Delete Save Progress",
        description = "You'll be given a few warnings before deleting!",
        table = "deletesave1",
        graphic = "KH_RECYCLE",
        sound = sfx_skid
    },
    {
        order = 2,
        name = "Print Effect",
        command2change = "SRB2CE_Print_Effect",
        description = "Prints to the console when you get an effect applied to you.",
        graphic = "KH_PRINT",
        type = "boolnum",
    },
    {
        order = 3,
        name = "Roulette SFX",
        command2change = "SRB2CE_Roulette_SFX",
        description = "Plays little sounds when the roulette is active.",
        graphic = "KH_AMPLIFIER",
        type = "boolnum",
    },
    {
        order = 4,
        name = "Memory",
        command2change = "SRB2CE_Memory",
        description = "Sets how many effects are remembered to not roll for.",
        values = searchoptionstable("SRB2CE_Memory").values,
        graphic = "KH_MEM",
        type = "number",
    },
    {
        order = 5,
        name = "HUD Text Border",
        command2change = "SRB2CE_HUD_Text_Border",
        description = "Enables a border around the text on the HUD.",
        graphic = "KH_TXT",
        type = "boolnum",
    },

    type = "options",
    name = "Misc. Items"
})

addMenu("deletesave1",
{
    {
        order = 1,
        name = "Delete Save Progress",
        description = "Hold on! Are you sure about that?",
        table = "deletesave2",
        graphic = "KH_RECYCLE",
        sound = sfx_alarm,
    },
    type = "options",
    name = "Are you sure?"
})

addMenu("deletesave2",
{
    {
        order = 1,
        name = "Delete Save Progress",
        description = "Are you POSITIVELY sure you want to delete your progress?",
        table = "deletesave3",
        graphic = "KH_RECYCLE",
        sound = sfx_gshd9,
    },
    type = "options",
    name = "Are you REALLY sure?"
})

addMenu("deletesave3",
{
    {
        order = 1,
        name = "Delete Save Progress (for real)",
        description = "\x85" + "Final warning.\x80 Are you COMPLETELY certain?",
        description2 = "We'll also have to kill your character, sorry.",
        --table = "deletesave3",
        intname = "DELETEITALL",
        price = -5, -- can't be 0, because reasons
        graphic = "KH_CRITICAL",
    },
    type = "shop",
    name = "Are you ABSOLUTELY sure?"
})

addMenu("optionsmenu",
{
    {
        order = 1,
        name = "Main Options",
        description = "Change your Chaos experience!",
        table = "mainoptions",
        graphic = "KH_OPTIONS"
    },
    {
        order = 2,
        name = "Toggle Effects",
        description = "Toggle which effects are enabled!",
        description2 = "This can affect your ring multiplier.",
        table = "blacklistmenu",
        graphic = "KH_CHECKLIST",
    },
    {
        order = 3,
        name = "Shoptions",
        description = "Adjusts things you've bought from the shop!",
        table = "shoptions",
        graphic = "KH_RINGBAGG",
    },
    --[[{
        order = 4,
        name = "Randomizer Options (DOESN'T EXIST YET)",
        description = "Adjusts things you've bought from the shop!",
        --table = "randomizermenu",
        graphic = "KH_RANDOMIZER",
    },]]
    {
        order = 4,
        name = "Misc. Items",
        --description = "a",
        table = "miscoptions",
        --TODO: add item to reset your save progress.
            -- nest the menus to REALLY make sure the player wants it. do it like the spongebob movie menus
                -- also fucking explode the player if they're in chaos city (but give them an extra life first (and take all their rings, just for in case of infinite lives))
        graphic = "KH_MOPTIONS"
    },
    {
        order = 5,
        name = "Attributions",
        description = "View all the credits for the people who made this possible!",
        table = "attributionsmenu",
        graphic = "KH_ATTR"
    },
    {
        order = 6,
        name = "Changelog",
        description = "View the changes between the last version of Chaotic Edtion",
        description2 = "and the one you're playing now!",
        table = "changelog",
        graphic = "KH_TXT"
    },
    --[[{
        order = 6,
        name = "Warp to Chaos City",
        description = "Warps you to Chaos City!",
        --DO NOT ALLOW THIS IN MULTIPLAYER.
        table = "warp2chaoscity",
        graphic = "KH_CHAOSCITY",
    },]]
    type = "catalog",
    name = "Settings"
})

addMenu("fxadded",
{
    {
        order = 1,
        name = "From TKK:",
        descriptiont =
        {"* Hey! Listen!",
        "* Timebomb",
        "* Laggy Model",
        "* Kids These Days",
        "* Hop!",
        "* Super Explosive 64",
        },
    },
    {
        order = 2,
        name = "Brand New:",
        descriptiont =
        {"* STOP! (Unlockable)",
        "* Downside Up",
        "* Money!",
        "* Omochao (unlockable)",
        "* Flamethrower",
        "* Broken Screen (unlockable)",
        "* but here's the spinner (unlockable)",
        "* The Treadmill Effect",
        "* Eye for an Eye",
        "* Pong",
        "* Rainbow Sneakers",
        "* :3",
        },
    },
    name = "FX Added",
    spacing = 1,
    maxitems = 3,
})

addMenu("ufxadded",
{
    {
        order = 1,
        name = "From TKK:",
        descriptiont =
        {
        "* You Get The Bees",
        "* The Most Attractive Player (takes the place of \"Black Hole\",", "   since it gives you it)",
        "* Out Of This World",
        "* Wacky Textures",
        },
    },
    {
        order = 2,
        name = "Brand New:",
        descriptiont =
        {
        "* Timestop",
        "* BOMBZ",
        "* Negative Rings (this replaces the effect of the same name)"
        },
    },
    name = "Universal FX",
    spacing = 1,
    maxitems = 3,
})

addMenu("fxtweaked",
{
    {
        order = 1,
        name = "", -- sure hope this works lol
        descriptiont =
        {
        '* "Bouncy!" has the wall bouncing logic changed.',
        '* "Rewind" now resets your camera, making it slightly less disorienting. I think.', -- this is literally right on the border of 16:10 (green) resolutions
        '* "Earthquake" utilizes the new 2.2.14 functions, now making it so not', '   everyone gets the same effect, due to there being a radius and epicenter.', '   This also means more than 1 person can have it applied at the same time.',
        '* "Change Character" now actually chooses random characters, instead', '  of heavily biasing towards picking one.',
        '* "Nuke" has a much larger blast radius now, and comes with 0 risk', '   of any shield shenanigans happening.',
        '* "Give Good Stuff" now adds to the timers instead of just replacing them.',
        '* "the pizza is aggressive" has had it\'s code ripped out and replaced;', '   the short of it is, this will work much better now.',
        '   - Also, the sounds have been upgraded to be a bit more audible.',
        '* "Tiny" makes you a little bit less... little. Meant to make things a...', '   little more bearable. (sorry)',
        },
    },
    {
        order = 2,
        name = "", -- sure hope this works lol
        descriptiont =
        {
        '* "Change Sprite" now copies the roll and pitch of the player.',
        '   - It also has a bunch of new sprites to choose from!',
        '* "Random Music" now looks through all the maps to get all the music tracks.', '   So, if you\'re on a custom level pack, music from those levels can be selected!',
        '   - It\'s also been changed to no longer have the music get changed back to', '      the normal music by things that would ordinarily restore the music ', '      (i.e. 1-up jingle, invincibility, etc.)',
        '* "Black Hole" is now classified as a Universal Effect.',
        '   - It also no longer attracts any solid objects if you\'re not in Amplified mode.',
        '* "Negative Rings" is also now a Universal Effect.',
        '   - Instead of how it worked before, random rings are now turned red, ', '      and those deplete your current ring count.',
        '* In general a lot of other effects have had their properties changed too,', '   there\'s too many changes to list here at this point :P',
        },
    },
    name = "Tweaked Effects",
    spacing = 1,
    maxitems = 1,
})

addMenu("changelog",
{
    {
        order = 1,
        name = "Massive rewrite has been implemented!",
        descriptiont =
        {"* This is the rewrite I did for Tails' Khaos Kontraption, this should 500%", "   improve stability.",
        "* Also included are some things I didn't do for TKK, like the faster ", "   roulette table (thus meaning your rolls will go faster)",
        "* This will also include expandability (i.e. mod support), so you can", "   create your own effects that can be loaded on-top of this!",
        },
        --table = "mainoptions",
    },
    {
        order = 2,
        name = "New single-player content!",
        descriptiont =
        {"* A hub level has been added called \"Chaos City\"; interact with Amy", "   to buy new things such as effects and such, and interact with Tails ", "   to adjust your options!",
        "* When you finish a level, you deposit all your rings into a bank, that you", "   can then use to spend on items in Amy's shop! There's also an important", "   (and cheap) upgrade you can get to keep your rings when damaged!",
        "   - Because of all of this, you are now incentivized to go for as many rings", "      as possible in a level, if you can avoid the chaos.",
        "* This mod should be compatible with other level packs, as it only ", "   replaces the tutorial level. If there's any incompatibilities, let ", "   me know, no guarantees I can fix it but I can try.",
        },
        --table = "mainoptions",
    },
    {
        order = 3,
        name = "New effects added!",
        description = "Jump in to me to find out what they are!",
        table = "fxadded",
    },
    {
        order = 4,
        name = "Universal Effects added, from Tails' Khaos Kontraption.",
        descriptiont = {"* This is an unlockable you can buy! Comes with an assortment of effects that", "  don't just affect the player, it affects the environment around you, ", "   and has a seperate global timer.", "* Jump in to me to find out what they are!"},
        table = "ufxadded",
    },
    {
        order = 5,
        name = "New menu system introduced (you're using it right now!)",
        descriptiont =
        {"* All the general settings have been put in here, allowing", "  for a non-confusing way to change up the mod to your liking.",
        "* Blacklist system has been overhauled and put into here, being called", "   \"Toggle Effects\", which can affect your ring multiplier!",
        "   - This will also show descriptions for the effects, ", "      giving you a brief glance at what they do.",
        },
        --table = "mainoptions",
    },
    {
        order = 6,
        name = "TKK specific changes, brought over to here:",
        descriptiont =
        {"* Icons have all been revamped, and are slightly bigger in size. They should", "   be more legible, hopefully!",
        "* A custom text renderer has been introduced (courtesy of l_fontlib.lua), just", "   for a different font to be used, one custom-made for TKK and this mod.",
        "* The HUD text system has been overhauled, looking a lot better w/ colored borders.",
        "* The timer bar now accounts for your screen resolution, that is to say,", "  it takes up the whole screen now.",
        "* You can disable the HUD altogether; this also disables many effect's ", "   starting sounds, meaning you won't have much idea of what effects are ", "   being applied to you!",
        },
        --table = "mainoptions",
    },
    {
        order = 7,
        name = "Tweaked certain effects",
        descriptiont = {"Jump in to me to find out what they are!"},
        table = "fxtweaked",
    },
    {
        order = 8,
        name = "General changed things:",
        descriptiont =
        {"* Effects are no longer preserved between levels.",
        "   - Justification is that this just isn't really needed, and caused a lot more", "      headaches programming-wise than it was worth.",
        "* On top of having a settings menu in Chaos City, you have access to it", "   via \"SRB2CE\". Use that instead of typing out confusing commands!",
        "* The save system has been re-worked entirely; settings should now", "   no longer cause \"NetXCMD\" issues if you were having them before.",
        "* The rainbow timer bar now runs slower, and has a", "   smoother transition when looping.",
        },
        --table = "mainoptions",
    },
    {
        order = 9,
        name = "There are enhancements exclusive for 2.2.14:",
        descriptiont =
        {
        '* "Ghost" and "Invisible" use the alpha tag; ergo, ', '   the player smoothly transitions to an invisible state.',
        '* Text borders have proper transparency',
        '* Earthquakes now have proper radiuses; not everyone will experience them now!',
        },
        --table = "mainoptions",
    },
    name = "Changelog",
    type = "catalog",
    spacing = 3,
    maxitems = 3,
})



local function constructattributionsmenu()
    if insertedblacklisttable then return end
    local thetable1 = {name = "Attributions",}
    local indexer1 = 0
    for key, value in pairs(SRB2CE.attributions) do
        indexer1 = $ + 1
        local insertion = {
            --order = indexer,
            name = value[1],
            order = indexer1,
            description = value[2],
            description2 = value[3],
            graphic = value[4],
            scale = value[5]
        }
        table.insert(thetable1, deepcopy(insertion))
    end

    addMenu("attributionsmenu", thetable1)
end

constructattributionsmenu()

addMenu("statistics",
{
    {
        order = 1,
        name = "Effects Rolled",
        description = "How many times did you roll a given effect?",
        description2 = "NOTICE: This isn't tracked in netgames.",
        table = "khaosmenu"
    },
    {
        order = 2,
        name = "Unlocks",
        description = "How much have you unlocked so far?",
        table = "khaosmenu"
    },
    {
        order = 3,
        name = "Achievements",
        description = "Look at what you've achieved!",
        table = "khaosmenu"
    },
    {
        order = 4,
        name = "Misc. Statistics",
        description = "Things like rings banked and damage taken goes here!",
        table = "khaosmenu"
    },
    type = "catalog",
    name = "Statistics & Info"
})

local function CalculateMultiplier(player)
    local thechanger = -30 -- start off with 0.7x ring multiplier, to make initial progression slightly slower
    local base = player.khaossp.basemulti

    local function Additioneer(check, worth)
        if check then
            base = $ + worth
        end
    end

    Additioneer(player.khaossp.amplifyanticheese, 25)
    Additioneer(player.khaossp.amyroof, 15)
    Additioneer(player.khaossp.prettycity, 20)
    Additioneer(player.khaossp.repairclock, 5)
    Additioneer(player.khaossp.arcade, 25)
    Additioneer(player.khaossp.fxpax1, 5)
    Additioneer(player.khaossp.fxpax2, 10)
    Additioneer(player.khaossp.drowned, 10)
    Additioneer(player.khaossp.hudtextborder, 5)
    Additioneer(player.khaossp.timerbarcolors, 5)
    Additioneer(player.khaossp.gamblecore, 5)
    Additioneer(player.khaossp.universalfx and tonumber(CV_FindVar("SRB2CE_Universal_Fx_Enabled").value), 20)
    Additioneer(player.khaossp.gamblecore and tonumber(CV_FindVar("SRB2CE_Gamblecore").value), 5)
    Additioneer(player.khaossp.annoyingfriend, abs(badeffectworth))
    Additioneer(player.khaossp.brokenscreen, abs(badeffectworth))
    Additioneer(not tonumber(CV_FindVar("SRB2CE_Ringkeep").value), 25)


    for key, value in pairs(player.khaossp.khaosblacklist) do
        if value then
            local thing = KhaosEffectsTable[indexOfName(KhaosEffectsTable, key)]
            if not thing.ignoremultiplier then -- done for effects that really shouldn't impact play if you disable them
                if thing.etype == "good" then
                    thechanger = $ + goodeffectworth
                elseif thing.etype == "bad" then
                    thechanger = $ + badeffectworth
                elseif thing.etype == "neutral" then
                    thechanger = $ + neutraleffectworth
                end
            end
        end
    end

    if thechanger <= -90 then --induce a minimum
        thechanger = -90
    end
    if thechanger >= 100 then --and a maximum
        thechanger = 100
    end

    player.khaossp.multiplier = base + thechanger
end

addHook("PlayerSpawn", function(player) --TODO: on spawn, check the player's blacklist, and figure what ring multiplier they should get
    if not player.khaosmenu then
        InitKhaosSP(player)
    end

    player.khaossp.dontload = nil
    player.khaosmenu = {} -- reset the menu entirely
    player.khaosmenu.previousmenus = {}
    player.khaosmenu.flashing = 0
    player.khaossp.warphover = nil
    player.khaossp.ktimespent = $ or 0
    player.khaossp.timeshitbykhaos = $ or 0
    player.khaossp.kringscollected = $ or 0
    player.khaossp.ringspent = $ or 0

    if not (player.pflags & PF_FINISHED) then -- just in case
        player.khaossp.depositring = false
    end
    CalculateMultiplier(player)

    if player.khaossp.hunter then
        player.khaossp.reenterhunter = true
    end

    if SRB2CE.AmplifyChecker(player) then
        player.khaossp.amplifyanticheese = true
    else
        player.khaossp.amplifyanticheese = true
    end
end)

SRB2CE.SetPlayerMenu = function(player, menu, mainmenu, dontinsert)
    if not player.khaos.OptionsLoaded then
        CONS_Printf(player, "Hold on, your settings haven't loaded yet!")
        return
    end
    if player.bot then
        return
    end
    if player.khaosmenu.menu and not dontinsert then
        table.insert(player.khaosmenu.previousmenus, {player.khaosmenu.menu, player.khaosmenu.page, player.khaosmenu.optionchosen})
    end

    player.khaosmenu.menu = menu
    player.khaosmenu.mainmenu = mainmenu or $
    player.khaosmenu.type = Khaos_ListOMenus[player.khaosmenu.menu].type
    player.khaosmenu.page = 1
    player.khaosmenu.optionchosen = 1
    --[[if player.khaossp.bank < 0 then
        player.khaossp.bank = 0
    end]]
    CalculateMultiplier(player)
    if tonumber(CV_FindVar("SRB2CE_Menu_Music").value) then
        S_ChangeMusic("OVWRS", nil, player, nil, (mapheaderinfo[gamemap].srb2cecity and S_GetMusicPosition()) or nil) --, 250, 250
    end
end

COM_AddCommand("CELOAD", function(player, section, var1, var2, var3, var4, var5, var6, var7, var8, var9)
    local gable = {var1, var2, var3, var4, var5, var6, var7, var8, var9}
    local compare = SRB2CE.items2save
    local playerable = player.khaossp
    local blacklistbable = {}

    section = tonumber($)
    if section > #SRB2CE.items2save / 9 then
        section = ($ - (#SRB2CE.items2save / 9)) - 1
        for index, value in ipairs(KhaosEffectsTable) do -- quickly construct a blacklist table
            if not value.noblacklist then
                table.insert(blacklistbable, {value.name, "bool"})
            end
        end
        compare = blacklistbable
        playerable = player.khaossp.khaosblacklist
    end
    --print(section)
    local glindex = 1
    for index, value in ipairs(compare) do
        if index > (section * 9)-1 and index < ((section+1) * 9) then
            --CONS_Printf(player, value[1])
            local applier = gable[glindex]
            if applier != "nil" then
                if value[2] == "number" then
                    applier = tonumber($)
                elseif value[2] == "bool" then
                    if applier == "true" then
                        applier = true
                    else
                        applier = false
                    end
                end
                playerable[value[1]] = applier
                SRB2CE.DebugPrint(player, value[1] + " should be " + applier)
            elseif value[4] != nil then
                playerable[value[1]] = value[4]
                SRB2CE.DebugPrint(player, value[1] + " should be " + value[4] + " (default value)")
            end
            --CONS_Printf(player, value[1] + " is set to " + converter(gable[glindex]))
            glindex = $ + 1
        end
    end
end)

local function ConstructSaveData(player, gabel, ptable, file)
    local file = "client/srb2chaoticedition/" + file + ".dat"
    --local gabel = SRB2CE.items2save
    local playbel = ptable
    local saver = {}
    --print(file)
    for index, value in ipairs(gabel) do
        local thevalue = playbel[value[1]]
        --print(tostring(index) .. ": " .. tostring(thevalue))
        saver[index] = thevalue
    end

    SaveData_I.WriteSaveFile(file, saver)
end

local function SaveSPContent2(player, section)
    if player != consoleplayer then return end

    local blacklistbable = {}
    for index, value in ipairs(KhaosEffectsTable) do -- quickly construct a blacklist table
        if not value.noblacklist then
            table.insert(blacklistbable, {value.name, "bool"})
        end
    end
    ConstructSaveData(player, SRB2CE.items2save, player.khaossp, "spcon")
    ConstructSaveData(player, blacklistbable, player.khaossp.khaosblacklist, "blacklist")
end

--[[addHook("ThinkFrame", function()
    if leveltime == 15*TICRATE then
        for key, value in pairs(players[1].khaossp) do
            print("k: " + key)
            print("v: " + value)
        end
    end
end)]]

local function MenuHandler(player, thechosenone, currentmenu)
    if thechosenone.table then
        SRB2CE.SetPlayerMenu(player, thechosenone.table)
        S_StartSound(nil, thechosenone.sound or sfx_menu1, player)
        return true
    end

    if thechosenone.command2change then
        local currentvalue = CV_FindVar(thechosenone.command2change).value
        if thechosenone.type == "boolnum" then
            if currentvalue == 1 then
                currentvalue = 0
            else
                currentvalue = 1
            end
            S_StartSound(nil, thechosenone.sound or sfx_menu1, player)
            COM_BufInsertText(consoleplayer, thechosenone.command2change + " " + currentvalue)
        elseif thechosenone.type == "number" then
            player.khaosmenu.optionchanger = thechosenone.command2change -- switch modes
            player.khaosmenu.optionchangervalues = thechosenone.values
            S_StartSound(nil, thechosenone.sound or sfx_menu1, player)
        end
        return true
    end

    if currentmenu.type == "warp" then
        if tonumber(CV_FindVar("SRB2CE_Menu_Music").value) then
            S_ChangeMusic("OVWRT", nil, player, nil, S_GetMusicPosition()) --, 250, 250
        end
        local thewarper = thechosenone.warp
        if thewarper == 6969 then
            thewarper = player.khaossp.previouslevel or 1100 -- fall back to 1100 (title screen) if we don't have a level.
        end
        player.khaossp.previouslevel = gamemap
        G_SetCustomExitVars(thewarper, 2)
        G_ExitLevel()
        S_StartSound(nil, thechosenone.sound or sfx_menu1, player)
        return true
    elseif currentmenu.type == "blacklist" then
        if player.khaossp.khaosblacklist[thechosenone.name] then
            player.khaossp.khaosblacklist[thechosenone.name] = nil
        else
            player.khaossp.khaosblacklist[thechosenone.name] = true
        end
        S_StartSound(nil, thechosenone.sound or sfx_menu1, player)
        return true
    elseif currentmenu.type == "starteffect" then
        if player.khaossp.starteffectchosen == thechosenone.key
            player.khaossp.starteffectchosen = nil
        else
            player.khaossp.starteffectchosen = thechosenone.key
        end
        S_StartSound(nil, thechosenone.sound or sfx_menu1, player)
        return true
    elseif currentmenu.type == "shop" then
        player.khaossp[thechosenone.intname] = true
        player.khaossp.bank = $ - thechosenone.price
        player.khaossp.ringspent = ($ and $ + thechosenone.price) or thechosenone.price
        S_StartSound(nil, thechosenone.sound or sfx_chchng, player)
        return true
    end
end

--[[
    local amystop = {
        [1] = {
            name = "Amy",
            portrait = {"amy", SPR2_STND, A, 8},
            color = SKINCOLOR_ROSY,
            text = "Hey!|pau05 Don't forget to visit Chaos City!",
            sound = sfx_chtam,
            delay = 2*TICRATE,
            next = 2
        },
        [2] = {
            name = "Amy",
            portrait = {"amy", SPR2_TRNS, G, 8},
            color = SKINCOLOR_ROSY,
            text = "We got lots of goodies to help you,|pau03 Sonic!",
            sound = sfx_chtam,
            delay = 2*TICRATE,
            next = 0
        },
    }


    if (player.cmd.buttons & BT_CUSTOM3) and not player.textBox.tree then
        TB:DisplayBox(player, amystop, true)
        hud.disable("crosshair")
        hud.disable("score")
        hud.disable("time")
        hud.disable("lives")
        hud.disable("rings")
        hud.disable("textspectator")
        player.mo.alpha = 0
        player.mo.shadowscale = 0
    end
]]

addHook("PlayerThink", function(player)
    player.khaossp.delayload = $ - 1
    player.khaossp.warpcooldown = max(0, $ - 1)

    if player.khaossp.playerpoints and player.khaossp.playerpoints > 9 then -- this is stupid but i'm lazy so
        player.khaossp.pongmaster = true
    end

    if not mapheaderinfo[gamemap].srb2cecity and not (player.pflags & PF_FINISHED) and not stoppedclock and (leveltime % TICRATE) == 0 then
        player.khaossp.ktimespent = ($ and $ + 1) or 1
    end

    if player.bot then
        player.khaossp.loadedsettings = true
        player.khaossp.blacklistloaded = true
    end

    if player.khaossp.DELETEITALL then
        player.khaosmenu.menu = nil
        player.khaosmenu.previousmenus = {} -- force purge
        player.khaossp.warphover = nil
        player.khaossp = nil
        InitKhaosSP(player)
        if G_GametypeUsesLives() then player.lives = $ + 1 end -- just to be nice :)

        local Explode = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
        S_StartSound(Explode, sfx_bkpoof)
        Explode.destscale = 4*player.mo.scale
        Explode.scalespeed = player.mo.scale/6
        P_KillMobj(player.mo)

        player.khaossp.dontload = true
        Khaos_SaveSettings(player, true)
        SaveSPContent2(player)
        return
    end

    if player.khaossp.dontload then
        return
    end

    if player.bot == 0 and player.khaossp and player.khaossp.delayload <= 0 then
        if not player.khaossp.loadedsettings or not player.khaossp.blacklistloaded then
            -- start player on a timer that ticks up no matter what.
            player.khaossp.loadtimer = $ or 0
            player.khaossp.loadtimer = $ + 1
            -- every 11th time of this, will count towards our section.
            local delay = (netgame and 11) or 2
            local blacklistable = {}
            for index, value in ipairs(KhaosEffectsTable) do -- quickly construct a blacklist table
                if not value.noblacklist then
                    table.insert(blacklistable, {value.name, "bool"})
                end
            end

            if (player.khaossp.loadtimer % delay) == 0 then
                local file = "spcon"
                if player.khaossp.loadedsettings then
                    file = "blacklist"
                end
                local thing = SaveData_I.ReadSaveFile("client/srb2chaoticedition/" + file + ".dat")
                local checktable = {}
                local checkertable = SRB2CE.items2save
                if not thing then
                    player.khaossp.loadedsettings = true
                    if file == "blacklist" then
                        player.khaossp.blacklistloaded = true
                    end
                else
                    local section = (player.khaossp.loadtimer / delay) - 1
                    local realsection = section
                    if player.khaossp.loadedsettings then
                        checkertable = blacklistable
                        section = ($ - (#SRB2CE.items2save / 9)) - 1
                    end
                    local stringer = ""
                    repeat
                        table.insert(checktable, {checkertable[#checktable+1][1], "nil"}) -- totally a real nil, trust me bro
                    until #checktable >= #checkertable

                    for key, value in pairs(thing) do
                        local soup = checktable[key][1]
                        checktable[key] = {soup, value}
                    end

                    for index, value in ipairs(checktable) do
                        if index > ((section * 9))-1 and index < ((section+1) * 9) then
                            stringer = $ .. tostring(value[2]) .. " "
                            --CONS_Printf(player, "index: " + index)
                            --CONS_Printf(player, "value: " + value)
                        end
                    end
                    stringer = realsection + " " + $
                    --CONS_Printf(player, "stringer: " + stringer)

                    SRB2CE.DebugPrint(player, "CELOAD " + stringer)
                    COM_BufInsertText(player, "CELOAD " .. stringer)
                    --#SRB2CE.items2save / 9
                    if section >= (#checkertable / 9) then
                        if player.khaossp.loadedsettings then
                            player.khaossp.blacklistloaded = true
                        end
                        player.khaossp.loadedsettings = true
                        SRB2CE.DebugPrint(player, "LOADED THING")
                    end
                end
            end
        end
    end


    if player.khaossp.warphover then
        local dist = max(1, R_PointToDist2(player.mo.x, player.mo.y, player.khaossp.warphover.x, player.khaossp.warphover.y))
        BootlegAttract(player.mo, player.khaossp.warphover, dist/6)
        player.mo.state = S_PLAY_FALL
        player.drawangle = $ + ANG1 + ANG1 + ANG1
    end


    if mapheaderinfo[gamemap].srb2cecity then
        if SRB2CE.AmplifyChecker(player) then --specifically for the menus
            player.khaossp.amplifyanticheese = true
        end
        player.khaossp.visitedcity = true
    end

    if not SRB2CE.AmplifyChecker(player) then
        player.khaossp.amplifyanticheese = false
    end

    --TODO: also get blacklist to have anticheese here, what you start with is what you end with

    -- !! TODO: DEBUG, REMOVE ME !! --
    --[[if player.khaosbt.custom3 == 1 then
        for key, value in pairs(player.khaossp.khaosblacklist) do
            SRB2CE.DebugPrint(player, key)
            SRB2CE.DebugPrint(player, value)
        end
    end]]

    --[[print(player.powers[pw_underwater])
    print(player.powers[pw_underwater]/TICRATE)]]


    -- knuckles freaks out over you drowning

    if mapheaderinfo[gamemap].srb2cecity then
        if player.powers[pw_underwater] == 10*TICRATE and player.khaossp.knuckles then
            local amystop = {
                [1] = {
                    name = "Knuckles",
                    portrait = {"knuckles", SPR2_WAIT, A, 8},
                    color = SKINCOLOR_RED,
                    text = "Hey uh, are you okay there, " + skins[player.mo.skin].realname + "?",
                    sound = sfx_talks,
                    delay = 2*TICRATE,
                    next = 0
                },
            }
            if not player.textBox.tree then
                TB:DisplayBox(player, amystop, true)
            end
        end

        if player.powers[pw_underwater] == 6*TICRATE-1 and player.khaossp.knuckles then
            local amystop = {
                [1] = {
                    name = "Knuckles",
                    portrait = {"knuckles", SPR2_STND, A, 8},
                    color = SKINCOLOR_RED,
                    text = "You're starting to freak me out, man.",
                    sound = sfx_talks,
                    delay = 2*TICRATE,
                    next = 0
                },
            }
            if not player.textBox.tree then
                TB:DisplayBox(player, amystop, true)
            end
        end

        if player.powers[pw_underwater] == 2*TICRATE-2 and player.khaossp.knuckles then
            local amystop = {
                [1] = {
                    name = "Knuckles",
                    portrait = {"knuckles", SPR2_PAIN, A, 8},
                    color = SKINCOLOR_RED,
                    text = "Get out of the water!!!!",
                    sound = sfx_talks,
                    delay = 3*TICRATE,
                    next = 0
                },
            }
            if not player.textBox.tree then
                TB:DisplayBox(player, amystop, true)
                --TODO: maybe add an achievment here for freaking out knuckles
                --player.khaossp.annoyingfriend = true
            end
        end

        if player.powers[pw_underwater] == 1 then -- you could technically earn this if you get out at the very VERY last tic you're able to.
            player.khaossp.drowned = true
        end
    end

    if player.khaosbt.jump > 0 and player.khaosmenu.lock then -- done to prevent the menu from jumping immediately in, after using the character text box
        player.khaosmenu.lock = true
    else
        player.khaosmenu.lock = false
    end

    -- ring bag logic --
    if (player.exiting > 0 or (player.pflags & PF_FINISHED)) and not player.khaossp.depositring and not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) then
        CalculateMultiplier(player)
        local ringcount = ((player.khaossp.multiplier * player.rings) / 100)
        player.khaossp.bank = $ + ringcount
        player.khaossp.depositring = true
        --SRB2CE.addHUDText(player, "Rings mutliplier: \x82" + fancymultiplier(player.khaossp.multiplier), true, 4*TICRATE, SKINCOLOR_GREEN)
        SRB2CE.addHUDText(player, "Banked: \x82" + ringcount + "\x80 using multiplier x\x82" + fancymultiplier(player.khaossp.multiplier), true, 6, SKINCOLOR_GREEN)
        if not player.bot then player.khaossp.kringscollected = $ + ringcount end
        SaveSPContent2(player)

        local signpost = player.mo -- fallback for in case there is no goal post
        local m = player.realmo
        local bagalreadyexists = false
        local range = 2160*FRACUNIT -- have a good distance to check
        searchBlockmap("objects", function(ref, found)
            if found.type == MT_SIGN and not bagalreadyexists then
                signpost = found
            end
            if found.type == MT_KHAOSRINGBAG then
                bagalreadyexists = true
                signpost = found
            end
        end, m, m.x-range, m.x+range, m.y-range, m.y+range)

        local timeser = 1
        if (signpost.flags2 & MF2_OBJECTFLIP) or (signpost.eflags & MFE_VERTICALFLIP) then
            timeser = -1
        end
        local moneybag
        if not bagalreadyexists then
            moneybag = P_SpawnMobj(signpost.x, signpost.y, signpost.z+(96*FRACUNIT*timeser), MT_KHAOSRINGBAG)
            P_SpawnMobj(signpost.x, signpost.y, signpost.z+(92*FRACUNIT*timeser), MT_RINGBAGENT)
            S_StartSound(moneybag, sfx_s3kb3)
            moneybag.angle = signpost.angle + ANGLE_180
            moneybag.endspawn = true
        else
            moneybag = signpost
        end
        moneybag.timer = 1

        repeat
            FakeRingBurst(player.mo, ringcount, nil, moneybag)
            ringcount = $ - 100
        until ringcount <= 0
    end

    -- menu logic --
    if player.khaosmenu.flashing > 0 then
        player.khaosmenu.flashing = $ - 1
    end

    if player.khaosmenu.menu then
        local currentmenu = Khaos_ListOMenus[player.khaosmenu.menu] -- DO NOT MODIFY THIS VARIABLE. AT ALL.
        player.pflags = $|PF_FULLSTASIS

        if not player.khaosmenu.optionchanger then
            if player.khaosbt.down == 1 or (player.khaosbt.down > 20 and (leveltime % 2 == 0)) then
                player.khaosmenu.optionchosen = $ + 1
                S_StartSound(nil, sfx_menu1, player)
            end
            if player.khaosbt.up == 1 or (player.khaosbt.up > 20 and (leveltime % 2 == 0)) then
                player.khaosmenu.optionchosen = $ - 1
                S_StartSound(nil, sfx_menu1, player)
            end
        end

        local maxitems = currentmenu.maxitems or 6

        if #currentmenu > maxitems and not player.khaosmenu.optionchangerthen -- we can do pages
            if not player.khaosmenu.optionchanger then
                if player.khaosbt.right == 1 or (player.khaosbt.right > 20 and (leveltime % 2 == 0)) then
                    player.khaosmenu.page = $ + 1
                    player.khaosmenu.optionchosen = 90000 -- force it into the max position
                    S_StartSound(nil, sfx_menu1, player)
                end
                if player.khaosbt.left == 1 or (player.khaosbt.left > 20 and (leveltime % 2 == 0)) then
                    player.khaosmenu.page = $ - 1
                    S_StartSound(nil, sfx_menu1, player)
                end
            end

            local slumber = #currentmenu
            local glumber = 0
            repeat
                slumber = $ - maxitems
                glumber = $ + 1
            until slumber <= 0

            if player.khaosmenu.page > glumber then
                player.khaosmenu.page = 1
            end
            if player.khaosmenu.page < 1 then
                player.khaosmenu.page = glumber
            end
        end

        local minvalue = maxitems*(player.khaosmenu.page-1)+1
        local maxvalue = min(maxitems*player.khaosmenu.page, #currentmenu)

        if player.khaosmenu.optionchosen > maxvalue then
            player.khaosmenu.optionchosen = minvalue
        end
        if player.khaosmenu.optionchosen < minvalue then
            player.khaosmenu.optionchosen = maxvalue
        end

        if player.bot then -- just in case
            player.khaosmenu.menu = nil
            player.khaossp.warphover = nil
        end

        if player.khaosbt.jump == 1 and not player.khaosmenu.lock then
            if not player.khaosmenu.optionchanger then
                local thechosenone
                local passrequirements = true
                for key, value in pairs(currentmenu) do -- sloppy way of doing this, but oh well
                    if type(value) == "number" then continue end -- i should be checking for table instead, but i don't want to fuck around with things too much in the last hours til release
                    if value.order == player.khaosmenu.optionchosen then
                        thechosenone = value
                    end
                end

                if thechosenone.savereq then
                    for key, value in pairs(thechosenone.savereq) do
                        if not player.khaossp[value] then
                            passrequirements = false
                        end
                    end
                end

                if thechosenone.admin and netgame and not IsPlayerAdmin(player) then
                    passrequirements = false
                end

                if currentmenu.type == "shop" and (not thechosenone.price or (player.khaossp[thechosenone.intname] or player.khaossp.bank < thechosenone.price)) then
                    passrequirements = false
                end

                if passrequirements then
                    local thing = MenuHandler(player, thechosenone, currentmenu)
                    if not thing then
                        --CONS_Printf(player, "SOMETHING WENT WRONG, WE'RE NOT DOING ANYTHING!!!!")
                        player.khaosmenu.flashing = 10
                        S_StartSound(nil, sfx_s3k7b, player)
                    end
                else
                    player.khaosmenu.flashing = 15
                    S_StartSound(nil, sfx_cdpcm9, player)
                end
            else
                player.khaosmenu.optionchanger = nil
                player.khaosmenu.optionchangervalues = nil
                S_StartSound(nil, sfx_chchng, player)
            end
            CalculateMultiplier(player)
        end

        if player.khaosmenu.optionchanger then
            local thevalueinquestion = CV_FindVar(player.khaosmenu.optionchanger).value

            if player.khaosbt.right == 1 or (player.khaosbt.right > 20 and (leveltime % 2 == 0)) then
                thevalueinquestion = $ + 1
                S_StartSound(nil, sfx_menu1, player)
            end
            if player.khaosbt.left == 1 or (player.khaosbt.left > 20 and (leveltime % 2 == 0)) then
                thevalueinquestion = $ - 1
                S_StartSound(nil, sfx_menu1, player)
            end

            --player.khaosmenu.optionchangervalues[1] -- min
            --player.khaosmenu.optionchangervalues[2] -- max
            if thevalueinquestion > player.khaosmenu.optionchangervalues[2] then
                thevalueinquestion = player.khaosmenu.optionchangervalues[1]
            end
            if thevalueinquestion < player.khaosmenu.optionchangervalues[1] then
                thevalueinquestion = player.khaosmenu.optionchangervalues[2]
            end

            --player.khaosmenu.optionchangervalues
            COM_BufInsertText(consoleplayer, player.khaosmenu.optionchanger + " " + thevalueinquestion)
        end

        if player.khaosbt.spin == 1 then
            if player.khaosmenu.optionchanger then
                player.khaosmenu.optionchanger = nil
                player.khaosmenu.optionchangervalues = nil
                S_StartSound(nil, sfx_chchng, player)
            elseif player.khaosmenu.menu != player.khaosmenu.mainmenu then
                local menuset = {player.khaosmenu.mainmenu, 1, 1} -- fallback
                --player.khaosmenu.previousmenus
                if #player.khaosmenu.previousmenus >= 1 then
                    menuset = player.khaosmenu.previousmenus[#player.khaosmenu.previousmenus]
                    table.remove(player.khaosmenu.previousmenus, #player.khaosmenu.previousmenus)
                end
                SRB2CE.SetPlayerMenu(player, menuset[1], nil, true)
                player.khaosmenu.page, player.khaosmenu.optionchosen = menuset[2], menuset[3]
                S_StartSound(nil, sfx_menu1, player)
            else
                player.khaosmenu.menu = nil
                player.khaosmenu.previousmenus = {} -- force purge
                player.khaossp.warphover = nil
                Khaos_SaveSettings(player, true)
                SaveSPContent2(player)
                --SaveSPContent2(player, 2)
                if not mapheaderinfo[gamemap].srb2cecity then
                    S_ChangeMusic(mapmusname, true, player) -- mapheaderinfo[gamemap].musname
                else
                    S_ChangeMusic("OVWRT", nil, player, nil, S_GetMusicPosition())
                end
                S_StartSound(nil, sfx_cdpcm9, player)
            end
        end
    end
end)

addHook("PreThinkFrame", function()
    for player in players.iterate do
        pbtDaemonkhaos(player)
    end
end)

local ringanimforward =
{
"RINGA0",
"RINGB0X0",
"RINGC0W0",
"RINGD0V0",
"RINGE0U0",
"RINGF0T0",
"RINGG0S0",
"RINGH0R0",
"RINGI0Q0",
"RINGJ0P0",
"RINGK0O0",
"RINGL0N0",
}

local ringanimreverse =
{
"RINGM0",
"RINGL0N0",
"RINGK0O0",
"RINGJ0P0",
"RINGI0Q0",
"RINGH0R0",
"RINGG0S0",
"RINGF0T0",
"RINGE0U0",
"RINGD0V0",
"RINGC0W0",
"RINGB0X0",
}

hud.add(function(v, player)
    if not player.khaosmenu or not player.khaosmenu.menu then v.khaosminit = false return end

    local currentmenu = Khaos_ListOMenus[player.khaosmenu.menu] -- DO NOT MODIFY THIS VARIABLE. AT ALL.

    if not v.khaosminit then
        v.khaosminit = true
        v.KhaosMTrans = 9
        v.bank = player.khaossp.bank
        v.baganim = 1
        v.ringstable = {}
    end

    if (leveltime % 2 == 0) and v.KhaosMTrans > 2 then
        v.KhaosMTrans = $ - 1
    end
    v.TransFlags = v.KhaosMTrans<<V_ALPHASHIFT
    v.drawScaled(0,200 , FRACUNIT*800, v.cachePatch("KH_DARK"), v.TransFlags|V_SNAPTOLEFT|V_SNAPTOTOP)

    if #v.ringstable > 0 then
        for key, value in pairs(v.ringstable) do
            if value.gravity < 8*FRACUNIT then
                value.gravity = $ + (FRACUNIT/4) + (FRACUNIT/2)
            end
            if value.velocity > FRACUNIT + (FRACUNIT/6) and (leveltime % 2 == 0) then
                value.velocity = $ - (FRACUNIT/3) - (FRACUNIT/6)
            end

            local velocity = value.velocity
            if value.direction then
                velocity = -$
            end
            value.x = $ + velocity
            value.y = $ + value.gravity

            value.frame = $ + 1
            if value.frame > 12 then
                value.frameflip = not $
                value.frame = 1
            end

            local sprite
            local flags
            if value.frameflip then
                flags = V_FLIP
                sprite = ringanimreverse[value.frame]
            else
                --ringanimforward
                sprite = ringanimforward[value.frame]
            end

            v.drawScaled(value.x, value.y, FRACUNIT/2, v.cachePatch(sprite), flags) --V_FLIP
            if value.y > 240*FRACUNIT then
                table.remove(v.ringstable, key)
            end
        end
    end

    v.drawScaled(24*FRACUNIT, 0*FRACUNIT, FRACUNIT, v.cachePatch("KH_RINGBAG" + tostring(v.baganim)))
    v.drawString(36, 30, ((v.bank > 0 and "\x82") or "\x85") + v.bank, V_ALLOWLOWERCASE, "thin-center")
    -- fancymultiplier(player.khaossp.multiplier)
    v.drawString(36, 38, "x" + ((player.khaossp.multiplier >= 100 and "\x83") or "\x82") + fancymultiplier(player.khaossp.multiplier), V_ALLOWLOWERCASE, "thin-center")
    --player.khaossp.multiplier

    if v.bank != player.khaossp.bank then
        if v.bank > player.khaossp.bank then
            v.bank = max($ - 7, player.khaossp.bank)
        end
        if v.bank < player.khaossp.bank --somehow we got more money
            v.bank = min($ + 7, player.khaossp.bank)
        end
        if (leveltime % 5 == 0) then
            v.baganim = $ + 1
            if v.baganim > 4 then
                v.baganim = 1
            end
            table.insert(v.ringstable, {x = 36*FRACUNIT, y = 30*FRACUNIT, velocity = v.RandomRange(0, 13)*FRACUNIT, direction = v.RandomChance(FRACUNIT/2), gravity = v.RandomRange(-9, -6)*FRACUNIT, frame = 0, frameflip = false})
            local thing = v.RandomRange(1, 3)
            if thing == 1 then
                S_StartSound(nil, sfx_choin1, player)
            elseif thing == 2 then
                S_StartSound(nil, sfx_choin2, player)
            else
                S_StartSound(nil, sfx_choin3, player)
            end
        end
    else
        if v.baganim != 1 then -- force animation to finish animation, as to not abruptly cut it off
            if (leveltime % 5 == 0) then
                v.baganim = $ + 1
                if v.baganim > 4 then
                    v.baganim = 1
                end
            end
        end
    end

    local slumber = #currentmenu
    local glumber = 0
    local maxitems = currentmenu.maxitems or 6
    repeat
        slumber = $ - maxitems
        glumber = $ + 1
    until slumber <= 0


    --v.drawString(120, 40, "Page: " + (player.khaosmenu.page + "/" + glumber + ", Position: " + player.khaosmenu.optionchosen), V_ALLOWLOWERCASE, "thin-center")


    --v.drawString(160, 40, "\x83" + tostring(currentmenu.name) , V_ALLOWLOWERCASE, "thin-center")
    v.draw(64, 0, v.cachePatch("KH_SHOPTITLE"))
    Fontlib.drawString(v, 160, 26, tostring(currentmenu.name), {font = "KHMNT"}, "center") -- "\x83" +

    --if glumber > 1 then v.drawString(120, 32, "Page: " + (player.khaosmenu.page + "/" + glumber) , V_ALLOWLOWERCASE, "thin-center") end
    if glumber > 1 then
        local leftarrow = " "
        local rightarrow = " "
        if player.khaosmenu.page > 1 then
            leftarrow = "\x82<-\x80"
        end
        if player.khaosmenu.page < glumber then
            rightarrow = "\x82->"
        end
        v.drawString(160, 190, leftarrow + "Page: " + (player.khaosmenu.page + "/" + glumber) + rightarrow , V_ALLOWLOWERCASE, "thin-center")

    end


    local maxitems = currentmenu.maxitems or 6

    local minvalue = maxitems*(player.khaosmenu.page-1)+1
    local maxvalue = min(maxitems*player.khaosmenu.page, #currentmenu)

    local ything = 0
    for key, value in pairs(currentmenu) do
        if type(value) == "table" and value.order and ((value.order >= minvalue) and (value.order <= maxvalue)) then
            -- if current option is this one, we put the cursor over it
            local pretext = ""

            local gabel = -- this is done so we can modify what we actually display
            {
                ["graphic"] = value.graphic,
                ["graphic2"] = value.graphic2,
                ["scale"] = value.scale,
                ["scale2"] = value.scale2,
                ["xoffset"] = value.xoffset,
                ["yoffset"] = value.yoffset,
                ["xoffset2"] = value.xoffset2,
                ["yoffset2"] = value.yoffset2,
                ["name"] = value.name,
                ["description"] = value.description,
                ["description2"] = value.description2,
                ["descriptiont"] = value.descriptiont,
            }

            local passrequirements = true
            local requirestring = ""
            local price
            local subpretext = "\x80"

            if value.savereq then
                for key, value in pairs(value.savereq) do
                    if not player.khaossp[value] then
                        local thing = intnametable[value].name
                        if intnametable[value].hidename and not player.khaossp[value] then --inception
                            thing = "???"
                        end
                        if #requirestring > 0 then
                            requirestring = $ +  ", " + thing
                        else
                            requirestring = $ + thing
                        end
                        passrequirements = false
                    end
                end
            end

            if value.admin and (netgame and not IsPlayerAdmin(player)) then
                passrequirements = false
            end

            if value.command2change then
                local setto = CV_FindVar(value.command2change).value
                if value.type == "boolnum" then
                    if setto == 0 then
                        setto = "off"
                    else
                        setto = "on"
                    end
                end
                if value.optionnames then
                    setto = value.optionnames[CV_FindVar(value.command2change).value+1]
                end
                price = "\x82Set to: \x80" + setto
            end

            if currentmenu.type == "blacklist" then
                local setto = player.khaossp.khaosblacklist[value.name]
                if not setto then
                    setto = "\x83\Enabled"
                else
                    setto = "\x85\Disabled"
                end

                price = "\x82\Effect is: \x80" + setto
            end

            --starteffectchosen

            if currentmenu.type == "starteffect" then
                local setto = (player.khaossp.starteffectchosen == value.key)
                if setto then
                    price = "\x83\Enabled"
                end
            end

            if player.khaosmenu.optionchosen == value.order then
                pretext = "\x83"
                if player.khaosmenu.optionchanger then
                    pretext = "\x82"
                    price = "<-- " + $ + " -->"
                end
            end

            if value.animated then
                local number = (leveltime/value.speed) % value.frames
                local extra = tostring((number % 100 < 10 and "0") or "")
                gabel.graphic = $ + extra + tostring(number)
            end

            if gabel.description2 == "%UNLOCKPERC" then
                --caluclate unlocks
                local unlockers = 0
                local amount = 0
                for k, v in pairs(SRB2CE.items2save) do
                    if not v[3] then
                        if player.khaossp[v[1]] then
                            unlockers = $ + 1
                        end
                        amount = $ + 1
                    end
                end
                local percentage = (unlockers * 100) / amount

                gabel.description2 = "\x83" + tostring(percentage) + "\x80" + "% unlocked!" --.. " + tostring(unlockers) + "/" + tostring(amount)
            end

            if currentmenu.type == "shop" and not value.price then
                passrequirements = false
            end

            if not passrequirements then
                --name = "???"
                pretext = "\x86"
                if player.khaosmenu.optionchosen == value.order then
                    pretext = "\x85"
                end
                subpretext = "\x86"
                local typer = "use"
                if currentmenu.type == "shop" then
                    typer = "buy"
                elseif currentmenu.type == "unlockstatistics" then
                    typer = "get"
                elseif currentmenu.type == "chaosinfo" or currentmenu.type == "fxinfo" then
                    typer = "see"
                end
                if currentmenu.type != "fxinfo" or value.hidename then
                    gabel.description = "Before you can " + typer + " this, you need to unlock:"
                    gabel.description2 = requirestring
                end
                if (netgame and not IsPlayerAdmin(player)) then
                    gabel.description = "You need to be an admin to use this!"
                    gabel.description2 = nil
                end
                if currentmenu.type != "fxinfo" then
                    price = "\x85" + "Unavailable"
                end
                if value.hidename then
                    gabel.name = "???"
                    gabel.graphic = "KH_UNKNOWN"
                    gabel.scale = nil
                    gabel.scale2 = nil
                    gabel.graphic2 = nil
                    gabel.xoffset = -1
                    gabel.yoffset = -2
                end
            end

            if currentmenu.type == "shop" and not value.price then
                gabel.description = value.description
                gabel.description2 = value.description2
            end

            if currentmenu.type == "warp" then
                local mapnum = value.warp
                if value.warp == 6969 then
                    mapnum = player.khaossp.previouslevel or 1000
                    if player.khaossp.previouslevel then
                        gabel.description2 = "\x82" + "Warp to: \x80" + G_BuildMapTitle(player.khaossp.previouslevel)
                    else
                        gabel.name = "Go back to Title Screen" -- naming it something different, hopefully to catch the player's attention a bit
                        gabel.description2 = "\x82" + "Warp to:\x80 Title Screen"
                    end
                end
                gabel.graphic = G_BuildMapName(mapnum) + "P"
                if not v.patchExists(gabel.graphic) then
                    gabel.graphic = "MAPZ0P" -- fallback for in case
                end
                gabel.mapgraphic = true
            end

            if value.intname then -- item that can be purchased
                if player.khaossp[value.intname] then -- has already been purchased
                    if player.khaosmenu.optionchosen == value.order then
                        pretext = "\x85"
                    else
                        pretext = "\x86"
                    end
                    price = "\x85" + "Sold out!"
                    subpretext = "\x86"
                else
                    if passrequirements then
                        if value.price and value.price > 0 then
                            price = "\x82\Cost: \x80" + value.price
                        end
                    end
                end
            end

            if currentmenu.type == "unlockstatistics" then
                local unlocked = player.khaossp[value.savevalue]
                if unlocked then
                    price = "\x83\Unlocked"
                else
                    price = "\x85\Not found yet!"
                end
            end

            if currentmenu.type == "statistics" then
                price = "\x83" + player.khaossp[value.savevalue]
                if value.type == "timer" then
                    local timer = player.khaossp[value.savevalue]
                    local hours = (timer / 3600)
                    local minutes = (timer / 60) % 60
                    local seconds = timer % 60
                    if seconds < 10 then
                        seconds = "0" .. tostring($)
                    end
                    if minutes < 10 then
                        minutes = "0" .. tostring($)
                    end

                    --local stringer = tostring(seconds)
                    -- convert to hh:mm:ss

                    price = "\x83" + tostring(hours) + ":" + tostring(minutes) + ":" + tostring(seconds)
                end

                if value.type == "timers" then
                    local timer = player.khaossp[value.savevalue]
                    local seconds = (timer / 35) % 60
                    local minutes = (timer / 35) / 60 -- if you somehow get more than 60 minutes, then fuck you, you don't get an hours counter
                    local miliseconds = ((timer % 35) * 100) / 35
                    if minutes < 10 then
                        minutes = "0" .. tostring($)
                    end
                    if seconds < 10 then
                        seconds = "0" .. tostring($)
                    end
                    if miliseconds < 10 then
                        miliseconds = "0" .. tostring($)
                    end

                    --local stringer = tostring(seconds)
                    -- convert to hh:mm:ss

                    price = "\x83" + tostring(minutes) + ":" + tostring(seconds) + "." + tostring(miliseconds)
                end
            end

            if player.khaosmenu.optionchosen == value.order --TODO: i've done this 3 times by now, isn't there a simpler way?
            and player.khaosmenu.flashing > 0 and (leveltime % 3 == 0) then
                if pretext == "\x83" then
                    pretext = "\x87"
                else
                    pretext = "\x82"
                end
            end

            if not gabel.mapgraphic then
                if gabel.graphic then
                    v.drawScaled(0+(gabel.xoffset or 0)*FRACUNIT, (50+ything+(gabel.yoffset or 0))*FRACUNIT, FRACUNIT/(gabel.scale or 2), v.cachePatch(gabel.graphic))
                end
                if gabel.graphic2 then
                    v.drawScaled(0+(gabel.xoffset2 or 0)*FRACUNIT, (50+ything+(gabel.yoffset2 or 0))*FRACUNIT, FRACUNIT/(gabel.scale2 or 2), v.cachePatch(gabel.graphic2))
                end
            else
                local scaler = (FRACUNIT/5 + FRACUNIT/5 + FRACUNIT/25)/2
                v.drawCropped(0+(gabel.xoffset or 0)*FRACUNIT, (50+ything+(gabel.yoffset or 0))*FRACUNIT, scaler, scaler, v.cachePatch(gabel.graphic), 0, nil, 58*FRACUNIT, 28*FRACUNIT, 44*FRACUNIT*2, 44*FRACUNIT*2)
            end
            v.drawString(24, 50+ything, pretext+gabel.name, V_ALLOWLOWERCASE, "thin")
            local priceoffset = 0
            if gabel.description then v.drawString(24, 50+7+ything, subpretext + gabel.description, V_ALLOWLOWERCASE, "small") priceoffset = $ + 5 end
            if gabel.description2 then v.drawString(24, 50+7+5+ything, subpretext + gabel.description2, V_ALLOWLOWERCASE, "small") priceoffset = $ + 5 end
            if gabel.descriptiont then
                for key, value in pairs(gabel.descriptiont) do
                    v.drawString(24, 50+7+ything, subpretext + value, V_ALLOWLOWERCASE, "small")
                    ything = $ + 5
                end
            end
            if price then v.drawString(24, 50+7+priceoffset+ything, price, V_ALLOWLOWERCASE, "small") end
            ything = $ + (currentmenu.spacing or 17) + 6
        end
    end
end, "game")

--[[ Note to self:
|delxy - Set delay between characters drawn, including spaces. Default is |del11 - 1 char per 1 tic. Decimal. Both MUST be nonzero, will be set to 1 if found as 0.
        x: how many characters to draw per tic
        y: how many tics to wait until the next char
|paunn - Pause for nn tics. This pauses AFTER drawing the next character. Decimal. MUST be nonzero, will be set to 1 if found as 0.
|shkn - Shake text. 1 - light, 2 - medium, 3 - intense
|wav - Wavy text
|rst - Reset
|esc - Parse escape sequence. Required (and recommended) for colors.
--]]

addHook("MapLoad", function()
    for mapthing in mapthings.iterate do
        if mapthing.type == 1 and not netgame
        and not (mapheaderinfo[gamemap].typeoflevel & TOL_NIGHTS) and not G_IsSpecialStage(gamemap)
        and not (mapheaderinfo[gamemap].bonustype == 1 or mapheaderinfo[gamemap].bonustype == 2) then
            local thinger = P_SpawnMobj(mapthing.x * FRACUNIT, mapthing.y * FRACUNIT, mapthing.z * FRACUNIT + (16 * FRACUNIT), MT_KHAOSMAPWARP)
            thinger.deactivated = true
            thinger.z = thinger.floorz + (16*FRACUNIT)
            --[[if mapthing.options & MTF_OBJECTFLIP then
                thinger.z = thinger.ceilingz - (16*FRACUNIT)
                thinger.flags2 = $ & MF2_OBJECTFLIP
                thinger.eflags = $ & MFE_VERTICALFLIP
            end]]
        end
    end

    if not mapheaderinfo[gamemap].srb2cecity return end

    for mo in mobjs.iterate() do
        if mo.type == MT_BLUECRAWLA then
            ReplaceMobj(mo, MT_KHAOSAMY)
        end
        if mo.type == MT_FORCE_BOX then
            if SUBVERSION < 14 and VERSION == 202 then
                ReplaceMobj(mo, MT_NULL)
            else
                ReplaceMobj(mo, MT_KHAOSMETAL)
            end
        end
        if mo.type == MT_RING_BOX then
            ReplaceMobj(mo, MT_KHAOSRINGBAG)
            mo.momz = 0
        end
        if mo.type == MT_REDCRAWLA then
            ReplaceMobj(mo, MT_KHAOSTAILS)
        end
        if mo.type == MT_GOLDBUZZ then
            mo.type = MT_KHAOSCLOCK
            mo.state = S_KHAOSCLOCK1
            mo.flags = MF_NOGRAVITY|MF_NOCLIP
        end

        if mo.type == MT_REDBUZZ then
            mo.type = MT_KHAOSCLOCK
            mo.state = S_KHAOSCLOCK2
            mo.flags = MF_NOGRAVITY|MF_NOCLIP
        end

        if mo.type == MT_SPRINGSHELL then
            mo.type = MT_KHAOSCLOCK
            mo.state = S_KHAOSCLOCK3
            mo.flags = MF_NOGRAVITY|MF_NOCLIP
        end
    end

    if os.date("%m") != "12" then
        for sector in sectors.iterate do
            if sector.taglist and sector.taglist.valid then
                for index = 1, #sector.taglist, 1 do
                    local tag = sector.taglist[index]
                    if tag == 133 then
                        for rover in sector.ffloors() do
                            if rover.toppic == "CHZFLR01" then
                                rover.flags = $ & ~FOF_EXISTS
                            end
                        end
                    elseif tag == 153 then
                        sector.floorheight = 8*FRACUNIT
                        sector.floorpic = "FPFLR2"
                    end
                end
            end
            --153
        end
        for line in lines.iterate do
            if line.tag == 154 or line.tag == 155 then --both are christmas tags; latter is for things that can work in 2.2.13
                line.frontside.midtexture = 0
                line.backside.midtexture = 0
            end
        end
    end

    if SUBVERSION < 14 and VERSION == 202 then -- remove the ornaments, they don't render right in 2.2.13
        for line in lines.iterate do
            if line.tag == 154 then
                line.frontside.midtexture = 0
                line.backside.midtexture = 0
            end
        end
    end
end) -- "MAPZ0"


addHook("TouchSpecial", function(special, toucher)
    if not toucher.player or not toucher.player.khaossp then
        return true
    end
    local player = toucher.player
    if player.bot then
        return true
    end
    if player.khaossp.warpcooldown == 0 then
        local thesilly = "warp2chaoscity"
        if mapheaderinfo[gamemap].srb2cecity then
            thesilly = "warpback"
        end
        SRB2CE.SetPlayerMenu(player, thesilly, thesilly)
        player.khaossp.warphover = special
    end

    player.khaossp.warpcooldown = max($, 1*TICRATE/2)

    return true
end, MT_KHAOSMAPWARP)

addHook("MobjThinker", function(mobj)
    A_GoldMonitorSparkle(mobj)
    if not S_OriginPlaying(mobj) then
        S_StartSoundAtVolume(mobj, sfx_chwarp, 90)
    end
    if token > 0 then -- warping when having tokens is broken, don't allow this!
        P_KillMobj(mobj)
    end
end, MT_KHAOSMAPWARP)

addHook("MobjThinker", function(mobj)
    local angler = ANG2
    if mobj.endspawn then
        angler = $ * 2
    end
    mobj.angle = $ + angler
    mobj.scale = 2*FRACUNIT
    if mobj.timer then
        mobj.timer = $ + 1
        if mobj.timer == 1*TICRATE + (TICRATE/2) then
            S_StartSound(mobj, sfx_prloop)
        end
        if mobj.timer > 5*TICRATE then -- for netgames.
            P_SpawnMobj(mobj.x, mobj.y, mobj.z-6*FRACUNIT, MT_RINGBAGENT)
            P_KillMobj(mobj)
        end
    end

end, MT_KHAOSRINGBAG)


addHook("MobjThinker", function(mobj)
    mobj.prevmomz = $ or mobj.momz
    if P_IsObjectOnGround(mobj) then
        mobj.momz = -FixedMul(mobj.prevmomz, FixedDiv(17*FRACUNIT,20*FRACUNIT))
    end
    if mobj.momz > 0 or mobj.momz < 0 then
        mobj.prevmomz = mobj.momz
    end

    mobj.timer = ($ and $ + 1) or 1

    if not mobj.target then
        P_SupermanLook4Players(mobj)
    end

    if (mobj.timer > 3*TICRATE) or (mobj.endspawn and mobj.timer > 1*TICRATE + (TICRATE/2)) then
        mobj.flags = $1 | MF_SPECIAL
        mobj.flags = $1 | MF_NOCLIP -- let nothing stop this
        if mobj.state == S_COLORRING then
            local target = mobj.target
            local dist = max(1, R_PointToDist2(target.x, target.y, mobj.x, mobj.y))
            BootlegAttract(mobj, target, dist/3 + dist/4)

            if mobj.endspawn and dist <= FRACUNIT/2 then
                S_StartSound(mobj, sfx_itemup)
                P_KillMobj(mobj)
            end
        end
    end

    if mobj.state != S_COLORRING then
        mobj.momx = 0
        mobj.momy = 0
        mobj.momz = 0
    end
end, MT_KHAOSFAKERING)

addHook("TouchSpecial", function(special, toucher)
    if not toucher.player or not toucher.player.khaossp or not mapheaderinfo[gamemap].srb2cecity then
        return true
    end
    local player = toucher.player
    S_StartSound(nil, sfx_chchng, player)

    SRB2CE.addHUDText(player, "You found \199" + "1,000\200\x80 rings!", 6)

    special.scale = FRACUNIT
    special.z = $ + special.height
    FakeRingBurst(special, 32, 30)
    special.angle = $ + ANG30
    FakeRingBurst(special, 32, 30)
    special.angle = $ + ANG30
    FakeRingBurst(special, 32, 30)

    player.khaossp.ringbag = true
    if player.khaossp.bank < 0 then -- just in case the literal first thing you do is grab this
        player.khaossp.bank = 0
    end
    player.khaossp.bank = $ + 1000
    player.khaossp.kringscollected = ($ and $ + 1000) or 1000

    --return true
end, MT_KHAOSRINGBAG)



local fangstop = {
    [1] = {
        name = "Fang",
        portrait = {"fang", SPR2_PAIN, A, 8},
        color = SKINCOLOR_LAVENDER,
        text = "|shk4Oi!|rst|pau05 The chest right there don't say \"free for all\", now does it?",
        sound = sfx_chtfa,
        delay = 2*TICRATE,
        next = 0
    },
}

addHook("LinedefExecute", function(line, caller, callsector)
    local player = caller.player
    --if SUBVERSION < 14 and VERSION == 202 then return end
    -- metal sonic won't actually appear in 2.2.14, but i still want this easter egg so... fuck it

    player.khaos.metaldetector = ($ and $ + 1) or 1 -- haha metal detector


    if player.khaos.metaldetector > 15*TICRATE then
        local text = "Boo."
        if player.khaossp.kringscollected - player.khaossp.ringspent != player.khaossp.bank then
            text = "Your wrongful actions have been undone."
            player.khaossp.bank = player.khaossp.kringscollected - player.khaossp.ringspent --max(0, min(player.khaossp.bank, player.khaossp.kringscollected - player.khaossp.ringspent))
        end
        local boo = {
            [1] = {
                name = "Metal Sonic",
                portrait = {"metalsonic", SPR2_TRNS, G, 8},
                color = SKINCOLOR_COBALT,
                text = text,
                sound = sfx_talks,
                delay = 2*TICRATE,
                next = 0
            },
        }
        local m = player.realmo
        local range = 2160*FRACUNIT
        searchBlockmap("objects", function(ref, found)
            if found.type == MT_KHAOSMETAL then
                found.activateme = true
            end
        end, m, m.x-range, m.x+range, m.y-range, m.y+range)
        if not player.textBox.tree then
            TB:DisplayBox(player, boo, true)
            P_KillMobj(player.mo)
        end
        player.khaos.metaldetector = 0
        player.khaossp.drowned = true -- technically not true, but i'm too lazy to change the variable name. assume i'm talking about that ben creepypasta or whatever
    end

end, "METALSHOP")

addHook("LinedefExecute", function(line, caller, callsector)
    local player = caller.player
    if not player then return end -- just in case
    if not player.khaossp.hunter then return end -- only do this when the player has fang unlocked
    player.khaossp.reenterhunter = true -- just for in case
    local greetings = "'ello there, |pau01" + skins[player.mo.skin].realname + "."
    local color = SKINCOLOR_LAVENDER
    local name = "Fang"
    local skin = "fang"
    local sound = sfx_chtfa
    if player.mo.skin == skin then
        greetings = "Oi, ya finally back to take over?"
    end
    if CheckClone(skin) then
        color = SKINCOLOR_SILVER
    end

    greetings = $ + " Don't got this shop open just yet, so why don'tcha come back later? I'll get something sorted in the future!"

    if not player.textBox.tree then
        local template = {
            [1] = {
                name = "Fang",
                portrait = {skin, SPR2_STND, A, 8},
                color = color,
                text = greetings,
                sound = sound,
                --delay = 5*TICRATE,
                next = 0
            },

            [2] = { -- This is going to be our choice prompt.
                choices = {
                    {text = "Talk to Fang", box = 4, pos = "ul"}, -- The option itself, then the box ID it takes you to, then the relative position.
                    {text = "???", box = 3, pos = "ur"} -- Try to position these so that scrolling with LTR makes sense.
                }
            },


            [3] = {
                name = name,
                portrait = {skin, SPR2_TRNS, G, 8},
                color = color,
                text = "Okay, I'll pull up the catalogues!",
                sound = sound,
                --delay = 2*TICRATE,
                next = 69
            },

            [69] = {
                name = name,
                portrait = {skin, SPR2_TRNS, G, 8},
                color = color,
                text = "",
                --sound = sound,
                delay = 1,
                script = function(player) -- This runs once the textbox is displayed. Can be used to lock the player out of activating the box again.
                    --player.weird = true
                    player.khaosmenu.lock = true
                    SRB2CE.SetPlayerMenu(player, "catalogsmenu", "catalogsmenu")
                end,
                next = 0
            },


            [4] = {
                name = name,
                portrait = {skin, SPR2_EDGE, A, 8},
                color = color,
                text = "Y'know, I swear I hear something moving around in the ceiling.|pau02|del13 |shk2I-is it a ghost|rst?",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            },
        }

        if player.khaossp.reenterhunter then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_PAIN, A, 8},
                color = color,
                text = "Why did Fang steal half the roof?|pau02 Just because we're in the clouds doesn't mean it can't rain here!!!",
                sound = sound,
                --delay = 2*TICRATE,
                next = 5
            }
            template[5] = {
                name = name,
                portrait = {skin, SPR2_WAIT, B, 8},
                color = color,
                text = "How did he even manage to steal only half of it...",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }
            if player.mo.skin == "fang" then
                template[4] = {
                    name = name,
                    portrait = {skin, SPR2_PAIN, A, 8},
                    color = color,
                    text = "Hey!!! Why did you steal half the roof?|pau02 Just because we're in the clouds doesn't mean it can't rain here!!!",
                    sound = sound,
                    --delay = 2*TICRATE,
                    next = 5
                }
                template[5] = {
                    name = name,
                    portrait = {skin, SPR2_WAIT, B, 8},
                    color = color,
                    text = "When did you even find the time to steal it, that's what I want to know...",
                    sound = sound,
                    --delay = 2*TICRATE,
                    next = 0
                }
            end
            if player.khaossp.amyroof then
                template[4] = {
                    name = name,
                    portrait = {skin, SPR2_WAIT, B, 8},
                    color = color,
                    text = "Well,|pau01 at least whatever was in my ceiling before isn't here anymore.|pau02 Must've escaped when Fang stole that part of the roof.",
                    sound = sound,
                    --delay = 2*TICRATE,
                    next = 5
                }
                template[5] = {
                    name = name,
                    portrait = {skin, SPR2_WAIT, B, 8},
                    color = color,
                    text = "Thanks for buying the repairs,|pau01 by the way.",
                    sound = sound,
                    --delay = 2*TICRATE,
                    next = 0
                }
                if player.mo.skin == "fang" then
                    template[4] = {
                        name = name,
                        portrait = {skin, SPR2_WAIT, B, 8},
                        color = color,
                        text = "Well,|pau01 at least whatever was in my ceiling before isn't here anymore.|pau02 Must've escaped when you stole that part of the roof. Thanks, I guess.",
                        sound = sound,
                        --delay = 2*TICRATE,
                        next = 0
                    }
                end
            end
        end

        if P_RandomChance(FRACUNIT/3) then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_WAIT, B, 8},
                color = color,
                text = "Apparantly,|pau03 the city down below is well known for it's beaches.|pau05 I would've thought it'd be the pretty pink grass!",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }
        end


        if player.khaossp.reenterhunter and P_RandomChance(FRACUNIT/4) then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_WAIT, A, 8},
                color = color,
                text = "Fang's pop gun is really loud and annoying,|pau02 why does he feel the need to use it at night?",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }
            if player.mo.skin == "fang" then
                template[4] = {
                    name = name,
                    portrait = {skin, SPR2_WAIT, A, 8},
                    color = color,
                    text = "Hey, your pop gun is really loud and annoying,|pau02 why do you feel the need to use it at night?",
                    sound = sound,
                    --delay = 2*TICRATE,
                    next = 0
                }
            end
        end

        if player.mo.skin != "amy" and P_RandomChance(FRACUNIT/3) then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_EDGE, A, 8},
                color = color,
                text = "Don't tell Amy 'bout this, but I could've sworn I saw some blue bird flew outta her roof when I dismantled it for myself.",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if player.mo.skin == "amy" and P_RandomChance(FRACUNIT/3) then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_WAIT, A, 8},
                color = color,
                text = "Hope there ain't any hard feelings between us. Only did what I had to do to stay safe, after all, ya invited me here.",
                sound = sound,
                --delay = 2*TICRATE,
                next = 5
            }
            template[5] = {
                name = name,
                portrait = {"amy", SPR2_TWIN, A, 8},
                color = player.mo.color,
                text = "...so you knew it can rain here, but you chose the half of the roof that I'm under?!",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 6
            }
            template[6] = {
                name = name,
                portrait = {skin, SPR2_CNT1, A, 8},
                color = color,
                text = "Oi, it ain't my fault that was the half that decided to start slippin' off!",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }

        end

        TB:DisplayBox(player, template)
        player.mo.momx = $ / 60
        player.mo.momy = $ / 60
        PointPlayer2NPC(player, MT_KHAOSFANG)
    end
end, "FANGSHOP")

addHook("LinedefExecute", function(line, caller, callsector)
    local player = caller.player
    if not player then return end -- just in case
    if not player.khaossp.knuckles then return end -- only do this when the player has knuckles unlocked
    local greetings = "Hey there, |pau01" + skins[player.mo.skin].realname + "."
    local color = SKINCOLOR_RED
    local name = "Knuckles"
    local skin = "knuckles"
    local sound = sfx_talks
    if player.mo.skin == skin then
        greetings = "Uhhh... hi me."
    end
    if CheckClone(skin) then
        color = SKINCOLOR_SILVER
    end

    --greetings = $ + " I don't have everything set up yet, come back later." --TEMPORARY, REMOVE LATER

    if not player.textBox.tree then
        local template = {
            [1] = {
                name = name,
                portrait = {skin, SPR2_STND, A, 8},
                color = color,
                text = greetings,
                sound = sound,
                --delay = 5*TICRATE,
                next = 2
            },

            [2] = { -- This is going to be our choice prompt.
                choices = {
                    {text = "Talk to Knuckles", box = 4, pos = "ul"}, -- The option itself, then the box ID it takes you to, then the relative position.
                    {text = "Show Chaos Info", box = 3, pos = "ur"} -- Try to position these so that scrolling with LTR makes sense.
                }
            },


            [3] = {
                name = name,
                portrait = {skin, SPR2_WAIT, A, 8},
                color = color,
                text = "Okay then.",
                sound = sound,
                --delay = 2*TICRATE,
                next = 69
            },

            [69] = {
                name = name,
                portrait = {skin, SPR2_TRNS, G, 8}, -- you can actually notice this for a single frame, but it's funny so i'm keeping this
                color = color,
                text = "",
                --sound = sound,
                delay = 1,
                script = function(player) -- This runs once the textbox is displayed. Can be used to lock the player out of activating the box again.
                    --player.weird = true
                    player.khaosmenu.lock = true
                    SRB2CE.SetPlayerMenu(player, "statisticsmenu", "statisticsmenu")
                end,
                next = 0
            },


            [4] = {
                name = name,
                portrait = {skin, SPR2_EDGE, A, 8},
                color = color,
                text = "Man, how did this even all happen?",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            },
        }

        if player.khaossp.reenterhunter and P_RandomChance(FRACUNIT/3) then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_PAIN, A, 8},
                color = color,
                text = "Fang keeps pestering me about gems, it's kinda annoying honestly.",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }
            if player.mo.skin == "fang" then
                template[4] = {
                    name = name,
                    portrait = {skin, SPR2_CNT1, A, 8},
                    color = color,
                    text = "If you're here to ask about where gems are, no, I don't know where they are.|pau07 Stop.|pau07 Asking.",
                    sound = sound,
                    --delay = 2*TICRATE,
                    next = 0
                }
            end
        end

        if P_RandomChance(FRACUNIT/4) then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_WAIT, B, 8},
                color = color,
                text = "I hear there's some |wav\"Special Rectangle\"|rst around here that,|pau03 if you stand in it for a little bit,|pau03 something cool happens.|pau07 I bet you get some cool weapon.",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if P_RandomChance(FRACUNIT/4) then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_WAIT, B, 8},
                color = color,
                text = "I have to wonder if there's some connection between the chaos causing this island to float, and Angel Island.|pau05 Something for Tails to figure out.",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        local plyrname = player.name
        if plyrname == "Sonic" then
            plyrname = "person behind the screen"
        end

        if player.khaossp.kringscollected - player.khaossp.ringspent != player.khaossp.bank and P_RandomChance(FRACUNIT/8) then
            template[4] = {
                name = name,
                portrait = {skin, SPR2_CNT1, B, 8},
                color = color,
                text = "Something's been bothering Tails lately...|pau09 you wouldn't have happened to done anything bad,|pau05 right,|pau03 " + plyrname + "?",
                sound = sound,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        TB:DisplayBox(player, template)
        player.mo.momx = 0
        player.mo.momy = 0
        PointPlayer2NPC(player, MT_KHAOSKNUX)
    end
end, "KNUXSHOP")

addHook("LinedefExecute", function(line, caller, callsector)
    local player = caller.player
    if not player then return end -- just in case
    local greetings = "Hi there, |pau01" + skins[player.mo.skin].realname + "!"
    local color = SKINCOLOR_ROSY
    local name = "Amy Rose"
    if player.mo.skin == "amy" then
        greetings = "Oh hi, me!"
    end
    if CheckClone("amy") then
        color = SKINCOLOR_SILVER
    end

    if os.date("%m") == "12" then
        greetings = $ + " Happy holidays!"
    end

    if not player.textBox.tree then
        local template = {
            [1] = {
                name = name,
                portrait = {"amy", SPR2_STND, A, 8},
                color = color,
                text = greetings,
                sound = sfx_chtam,
                --delay = 5*TICRATE,
                next = 2
            },

            [2] = { -- This is going to be our choice prompt.
                choices = {
                    {text = "Talk to Amy", box = 4, pos = "ul"}, -- The option itself, then the box ID it takes you to, then the relative position.
                    {text = "Shop", box = 3, pos = "ur"} -- Try to position these so that scrolling with LTR makes sense.
                }
            },


            [3] = {
                name = name,
                portrait = {"amy", SPR2_TRNS, G, 8},
                color = color,
                text = "Okay, I'll pull up the catalogues!",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 69
            },

            [69] = {
                name = name,
                portrait = {"amy", SPR2_TRNS, G, 8},
                color = color,
                text = "",
                --sound = sfx_chtam,
                delay = 1,
                script = function(player) -- This runs once the textbox is displayed. Can be used to lock the player out of activating the box again.
                    --player.weird = true
                    player.khaosmenu.lock = true
                    SRB2CE.SetPlayerMenu(player, "catalogsmenu", "catalogsmenu")
                end,
                next = 0
            },


            [4] = {
                name = name,
                portrait = {"amy", SPR2_EDGE, A, 8},
                color = color,
                text = "Y'know, I swear I hear something moving around in the ceiling.|pau02|del13 |shk2I-is it a ghost|rst?",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            },
        }

        if player.khaossp.reenterhunter then
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_PAIN, A, 8},
                color = color,
                text = "Why did Fang steal half the roof?|pau02 Just because we're in the clouds doesn't mean it can't rain here!!!",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 5
            }
            template[5] = {
                name = name,
                portrait = {"amy", SPR2_WAIT, B, 8},
                color = color,
                text = "How did he even manage to steal only half of it...",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
            if player.mo.skin == "fang" then
                template[4] = {
                    name = name,
                    portrait = {"amy", SPR2_PAIN, A, 8},
                    color = color,
                    text = "Hey!!! Why did you steal half the roof?|pau02 Just because we're in the clouds doesn't mean it can't rain here!!!",
                    sound = sfx_chtam,
                    --delay = 2*TICRATE,
                    next = 5
                }
                template[5] = {
                    name = name,
                    portrait = {"amy", SPR2_WAIT, B, 8},
                    color = color,
                    text = "When did you even find the time to steal it, that's what I want to know...",
                    sound = sfx_chtam,
                    --delay = 2*TICRATE,
                    next = 0
                }
            end
            if player.khaossp.amyroof then
                template[4] = {
                    name = name,
                    portrait = {"amy", SPR2_WAIT, B, 8},
                    color = color,
                    text = "Well,|pau01 at least whatever was in my ceiling before isn't here anymore.|pau02 Must've escaped when Fang stole that part of the roof.",
                    sound = sfx_chtam,
                    --delay = 2*TICRATE,
                    next = 5
                }
                template[5] = {
                    name = name,
                    portrait = {"amy", SPR2_WAIT, B, 8},
                    color = color,
                    text = "Thanks for buying the repairs,|pau01 by the way.",
                    sound = sfx_chtam,
                    --delay = 2*TICRATE,
                    next = 0
                }
                if player.mo.skin == "fang" then
                    template[4] = {
                        name = name,
                        portrait = {"amy", SPR2_WAIT, B, 8},
                        color = color,
                        text = "Well,|pau01 at least whatever was in my ceiling before isn't here anymore.|pau02 Must've escaped when you stole that part of the roof.|pau07 Thanks,|pau03 I guess.",
                        sound = sfx_chtam,
                        --delay = 2*TICRATE,
                        next = 0
                    }
                end
            end
        end

        if P_RandomChance(FRACUNIT/3) then
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_CNT1, B, 8},
                color = color,
                text = "I don't know why this store is stocked with grass|del14...|del11 like, did they really need a store just to sell grass?",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 5
            }
            template[5] = {
                name = name,
                portrait = {"amy", SPR2_PAIN, A, 8},
                color = color,
                text = "It's not even the same color as the grass out here!",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if P_RandomChance(FRACUNIT/3) then
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_WAIT, B, 8},
                color = color,
                text = "Apparantly,|pau03 the city down below is well known for it's beaches.|pau05 I would've thought it'd be the pretty pink grass!",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if P_RandomChance(FRACUNIT/3) and os.date("%m") == "12" then
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_WAIT, B, 8},
                color = color,
                text = "It's too bad we don't have a chimney for Santa...|pau15 wait, is he gonna be okay throughout all this chaos?",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end


        if P_RandomChance(FRACUNIT/3) then
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_EDGE, A, 8},
                color = color,
                text = ((player.mo.skin != "amy" and "Sorry this stuff isn't free here,|pau03 " + skins[player.mo.skin].realname + ".") or "It's such ashame the stuff here isn't free.") + "|pau05 Chaos augmentations require a lot of chaos energy, and the rings you collect are the ripest source of them!",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if player.khaossp.reenterhunter and P_RandomChance(FRACUNIT/4) then
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_WAIT, A, 8},
                color = color,
                text = (player.mo.skin != "fang" and "Fang's pop gun is really loud and annoying,|pau02 why does he feel the need to use it at night?") or
                "Hey, your pop gun is really loud and annoying,|pau02 why do you feel the need to use it at night?",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if player.mo.skin == "amy" and P_RandomChance(FRACUNIT/3) and not CheckClone("sonic") then
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_EDGE, A, 8},
                color = color,
                text = "Have you seen Sonic out there yet?|pau08 |del13|shk1O-oh, no reason...",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if player.mo.skin != "amy" and (player.khaossp.playerpoints and player.khaossp.playerpoints > 50) and P_RandomChance(FRACUNIT/3) then -- bully time, technically you could probably get this dialogue without the pong machine being unlocked, but you'd be a masochist for doing that. ...you're gonna do that because you read this text, aren't you?
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_STND, A, 8},
                color = color,
                text = "Wow, you really like to play that pong machine over there, huh.",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        local plyrname = player.name
        if plyrname == "Sonic" then
            plyrname = "person behind the screen"
        end

        if player.khaossp.kringscollected - player.khaossp.ringspent != player.khaossp.bank and P_RandomChance(FRACUNIT/6) then
            template[4] = {
                name = name,
                portrait = {"amy", SPR2_CNT1, B, 8},
                color = color,
                text = "Say,|pau05 " + plyrname + "|del16...|rst|del12 why did you cheat?",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        TB:DisplayBox(player, template)
        player.mo.momx = $ / 60
        player.mo.momy = $ / 60
        PointPlayer2NPC(player, MT_KHAOSAMY)
    end
end, "AMYSHOP")

addHook("LinedefExecute", function(line, caller, callsector)
    local player = caller.player
    if not player then return end -- just in case
    local greetings = "Heya, |pau01" + skins[player.mo.skin].realname + "!"
    local color = SKINCOLOR_ORANGE
    if player.mo.skin == "tails" then
        greetings = "Hey there,|pau02 me."
    end

    if CheckClone("tails") then
        color = SKINCOLOR_SILVER
    end

    if not player.textBox.tree then
        local template = {
            [1] = {
                name = "Tails",
                color = color,
                sound = sfx_chtta,
                portrait = {"tails", SPR2_STND, A, 8},
                text = greetings,
                --delay = 5*TICRATE,
                next = 2
            },

            [2] = { -- This is going to be our choice prompt.
                choices = {
                    {text = "Talk to Tails", box = 5, pos = "ul"}, -- The option itself, then the box ID it takes you to, then the relative position.
                    {text = "Change Options", box = 3, pos = "ur"} -- Try to position these so that scrolling with LTR makes sense.
                }
            },

            [3] = {
                name = "Tails",
                color = color,
                sound = sfx_chtta,
                portrait = {"tails", SPR2_STND, A, 8},
                text = "Alright, here you go!",
                --delay = 2*TICRATE,
                next = 4
            },

            [4] = {
                name = "Tails",
                color = color,
                text = "",
                portrait = {"tails", SPR2_STND, A, 8},
                --sound = sfx_chtta,
                delay = 1,
                script = function(player) -- This runs once the textbox is displayed. Can be used to lock the player out of activating the box again.
                    --player.weird = true
                    player.khaosmenu.lock = true
                    SRB2CE.SetPlayerMenu(player, "optionsmenu", "optionsmenu")
                end,
                next = 0
            },

            [5] = {
                name = "Tails",
                portrait = {"tails", SPR2_STND, A, 8},
                color = color,
                text = "I'm glad the teleporter I built worked first try. I still have nightmares about the last one I made.",
                sound = sfx_chtta,
                --delay = 2*TICRATE,
                next = 0
            }
        }

        if P_RandomChance(FRACUNIT/2) then
            template[5] = {
                name = " Tails",
                portrait = {"tails", SPR2_WAIT, A, 8},
                color = color,
                text = "Before you ask, I can't stop the teleporter from making that weird sound.",
                sound = sfx_chtta,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if P_RandomChance((FRACUNIT/2) + (FRACUNIT/4)) then
            template[5] = {
                name = " Tails",
                portrait = {"tails", SPR2_STND, A, 8},
                color = color,
                text = "I didn't know rings had this much chaos energy in them. I knew they had some, but not enough to do this!",
                sound = sfx_chtta,
                --delay = 2*TICRATE,
                next = 6
            }
            template[6] = {
                name = " Tails",
                portrait = {"tails", SPR2_STND, A, 8},
                color = color,
                text = "The pure essence of chaos in these rings are very potent... I hope we can use their power to revert all this.",
                sound = sfx_chtta,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if player.mo.skin == "tails" and P_RandomChance(FRACUNIT/3) then
            template[5] = {
                name = " Tails",
                portrait = {"tails", SPR2_TIRE, A, 8},
                color = color,
                text = "|del12Are you returning back to base now? My battery is running low...",
                sound = sfx_chtta,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if P_RandomChance(FRACUNIT/20) then
            template[5] = {
                name = " Tails",
                portrait = {"tails", SPR2_STND, A, 8},
                color = color,
                text = "Have you noticed the stop signs have differently shaped posts?|pau04 It's been bothering me...",
                sound = sfx_chtta,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if player.khaossp.universalfx and P_RandomChance(FRACUNIT/5) then
            template[5] = {
                name = " Tails",
                portrait = {"tails", SPR2_STND, A, 8},
                color = color,
                text = "Y'know, it was a lotta hard work ripping out the Universal Effects engine I made.|pau05 Hope the augmentation was worth it.",
                sound = sfx_chtta,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        local plyrname = player.name
        if plyrname == "Sonic" then
            plyrname = "person behind the screen"
        end

        if player.khaossp.kringscollected - player.khaossp.ringspent != player.khaossp.bank and P_RandomChance(FRACUNIT/4) then
            template[5] = {
                name = " Tails",
                portrait = {"tails", SPR2_DEAD, A, 8},
                color = color,
                text = "Hey,|pau05 " + plyrname + "|del13...|rst|del12 it's not fair to cheat.",
                sound = sfx_chtta,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        if P_RandomChance(FRACUNIT/99) then
            template[5] = {
                name = " Tails?",
                portrait = {"amy", SPR2_WAIT, A, 8},
                color = color,
                text = "Wait... I'm not supposed to be Amy!",
                sound = sfx_chtam,
                --delay = 2*TICRATE,
                next = 0
            }
        end

        TB:DisplayBox(player, template)
        player.mo.momx = $ / 60
        player.mo.momy = $ / 60
        PointPlayer2NPC(player, MT_KHAOSTAILS)
    end
end, "TAILSSHOP")

addHook("LinedefExecute", function(line, caller, callsector)
    local player = caller.player

    local sound = sfx_talks
    if player.mo.skin == "amy" then
        sound = sfx_chtam
    elseif player.mo.skin == "tails" then
        sound = sfx_chtta
    elseif player.mo.skin == "fang" then
        sound = sfx_chtfa
    end

    local arcadetree = {
        [1] = {
            name = skins[player.mo.skin].realname,
            portrait = {player.mo.skin, SPR2_WAIT, A, 8},
            color = skins[player.mo.skin].prefcolor,
            text = "Huh,|pau02 it seems this arcade machine is busted.|pau04 Maybe it can be fixed?",
            sound = sound,
            --delay = 5*TICRATE,
            next = 0
        },
    }

    if player.khaossp.arcade then
        if player.khaossp.playerpoints and player.khaossp.playerpoints > 9 then
            arcadetree = {
                    [1] = {
                        name = skins[player.mo.skin].realname,
                        portrait = {player.mo.skin, SPR2_WAIT, A, 8},
                        color = skins[player.mo.skin].prefcolor,
                        text = "There's two games I can choose now, which one do I pick?",
                        sound = sound,
                        --delay = 5*TICRATE,
                        next = 2
                    },

                    [2] = { -- This is going to be our choice prompt.
                        choices = {
                            {text = "Pong", box = 3, pos = "ul"}, -- The option itself, then the box ID it takes you to, then the relative position.
                            {text = "Chaos Pong", box = 4, pos = "ur"} -- Try to position these so that scrolling with LTR makes sense.
                        }
                    },


                    [3] = {
                        name = "",
                        portrait = {player.mo.skin, SPR2_WAIT, A, 8},
                        color = skins[player.mo.skin].prefcolor,
                        text = "",
                        sound = sound,
                        delay = 1,
                        script = function(player) -- This runs once the textbox is displayed. Can be used to lock the player out of activating the box again.
                            player.khaos.sppong = true
                            player.khaos.pongtime = true
                        end,
                        next = 0
                    },

                    [4] = {
                        name = "",
                        portrait = {player.mo.skin, SPR2_WAIT, A, 8},
                        color = skins[player.mo.skin].prefcolor,
                        text = "",
                        sound = sound,
                        delay = 1,
                        script = function(player) -- This runs once the textbox is displayed. Can be used to lock the player out of activating the box again.
                            player.khaos.sppong = true
                            player.khaos.chaospong = true
                            player.khaos.pongtime = true
                        end,
                        next = 0
                    },
                }

        else
            player.khaos.sppong = true
            player.khaos.pongtime = true
            player.mo.momx = $ / 60
            player.mo.momy = $ / 60
            player.drawangle = ANGLE_270
            return
        end
    end



    if not player.textBox.tree then
        TB:DisplayBox(player, arcadetree)
        player.mo.momx = $ / 60
        player.mo.momy = $ / 60
        player.drawangle = ANGLE_270
    end
end, "ARCADE")

addHook("LinedefExecute", function(line, caller, callsector)
    local player = caller.player
    local color = SKINCOLOR_ROSY
    if CheckClone("amy") then
        color = SKINCOLOR_SILVER
    end
    local amystop = {
        [1] = {
            name = "Amy",
            portrait = {"amy", SPR2_PAIN, A, 8},
            color = color,
            text = "|del13|shk2H-|pau02hey!|rst|pau05|del11 What are you doing back here?!",
            sound = sfx_chtam,
            delay = 2*TICRATE,
            next = 0
        },
    }
    local amyhi = {
        [1] = {
            name = "Amy",
            portrait = {"amy", SPR2_STND, A, 8},
            color = color,
            text = "|del13|shk2O-|pau02oh!|rst|pau05|del11 Are you ready to take over?",
            sound = sfx_chtam,
            delay = 2*TICRATE,
            next = 0
        },
    }
    if not player.textBox.tree then
        if player.mo.skin == "amy" then
            TB:DisplayBox(player, amyhi, true)
        else
            TB:DisplayBox(player, amystop, true)
            player.khaossp.annoyingfriend = true
        end
    end
end, "AMYSTOP")

addHook("LinedefExecute", function(line, caller, callsector)
    local player = caller.player
    local color = SKINCOLOR_ORANGE
    if CheckClone("tails") then
        color = SKINCOLOR_SILVER
    end
    local tailsstop = {
        [1] = {
            name = "Tails",
            portrait = {"tails", SPR2_PAIN, A, 1},
            color = color,
            sound = sfx_chtta,
            text = "|del14|shk4Heyyyyy!|rst|pau05|del11 " + skins[player.mo.skin].realname + ", why did you do that?!",
            delay = 2*TICRATE,
            next = 0
        },
    }

    if player.khaossp.brokenscreen then
        tailsstop = {
            [1] = {
                name = "Tails",
                portrait = {"tails", SPR2_PAIN, A, 1},
                color = color,
                sound = sfx_chtta,
                text = "Quit it " + skins[player.mo.skin].realname + ",|pau05 it's not funny the second time!",
                delay = 2*TICRATE,
                next = 0
            },
        }
    end

    if not player.textBox.tree then
        TB:DisplayBox(player, tailsstop, true)
        --player.khaossp.annoyingfriend = true
        player.khaossp.brokenscreen = true
    end
end, "TAILSSTOP")
